/* main.js */

// The following comments are for JSLint
/*jslint nomen: true, white: true, vars: true */
/*global document, window, screen, console, M */

var G = ( function () {
	"use strict";

	// Any property of <sys> becomes a public property of G

	var sys = {

        // Improved typeof by Doug Crockford, with NaN/Infinity detection by Moriarty

       _type : function ( val ) {
            var t;

            t = typeof val;
            if ( t === "number" ) {
                if ( isNaN( val ) ) {
                    t = "NaN";
                }
                else if ( !isFinite( val ) ) {
                    t = "Infinity";
                }
            }
            else if ( t === "object" ) {
                if ( val ) {
                    if ( val instanceof Array ) {
                        t = "array";
                    }
                }
                else {
                    t = "null";
                }
            }
            return t;
        },

		init : function ( str ) {
			var renderer, box, box2;

			renderer = G.pixi.init();
            G.menu.init();
			G.ui.init();
			G.text.init( renderer );
			G.pixi.start();

            if ( str !== undefined ) {
                G.pixi.preLoadProject( str );
            }
            // Create a 1-line text box that you can click to edit

			//box = G.text.create( 1, -1, function () {
             //   G.text.edit( box, true );
            //} );
			//G.text.resize( box, 128, 128, 128, 128 );
			//G.text.set( box, "W" );
            //G.text.edit( box, true );
			//G.text.show( box );

		}
	};

	return sys;
} () );

