// menu.js

// The following comments are for JSLint
/*jslint nomen: true, white: true, vars: true */
/*global document, window, screen, console, G */

G.menu = ( function () {
	"use strict";

	// DOM element IDs

	var newProject = null;

	var endEvent = function ( event ) {
		if ( event.stopPropagation ) {
			event.stopPropagation();
		}
		else {
			event.cancelBubble = true;
		}
		event.preventDefault(); // prevents weirdness
		return false;
	};

	var Preload = function ( event ) {
        G.pixi.preLoadProject(event.target.id);

		return endEvent( event );
	};

    var clearing = function ( event ) {
        var val, str, e;
        var action=event.target.id;

        if(action==="menu_file_newProject" || action==="menu_edit_clear")
        {
            G.pixi.clearAll();
        }
        else if(action==="menu_edit_delete")
        {
            str = "Toggle Clearing [";
            val = G.pixi.toggleRemoving();
            if ( val ) {
                str += "On]";
            }
            else {
                str += "Off]";
            }
            e = document.getElementById( "menu_edit_delete" );
            e.innerHTML = str;
        }
        else if(action==="menu_edit_four")
        {
            str = "Toggle Four Boards [";
            val = G.pixi.toggleFourBoards();
            if ( val ) {
                str += "On]";
            }
            else {
                str += "Off]";
            }
            e = document.getElementById( "menu_edit_four" );
            e.innerHTML = str;
        }
        else if(action==="menu_edit_real")
        {
            str = "Toggle Realistic [";
            val = G.pixi.toggleRealism();
            if ( val ) {
                str += "On]";
            }
            else {
                str += "Off]";
            }
            e = document.getElementById( "menu_edit_real" );
            e.innerHTML = str;
        }

        return endEvent( event );
    };

    var saveLoad = function ( event ) {
        var action=event.target.id;

        if(action==="menu_file_save")
        {
            G.pixi.saveProject();
        }
        else if(action==="menu_file_load")
        {
            G.pixi.loadProject(G.monitor.get());
        }


        return endEvent( event );
    };

	var hookup = function ( str, exec ) {
		var e;

		e = document.getElementById( str );
		e.addEventListener( "mousedown", exec, false );
		return e;
	};

	var sys = {
		init : function () {

			hookup( "Flashlight", Preload );
            hookup( "HallLight", Preload );
            hookup( "Doorbell", Preload );
            hookup( "PorchLight", Preload );
            hookup( "BurglarAlarm", Preload );
            hookup( "Furnace", Preload );
            hookup( "Signals", Preload );
            hookup( "Airlock", Preload );
            hookup( "FarmMachine", Preload );
            hookup( "JellWives", Preload );
            hookup( "MacWill", Preload );
            hookup( "ThreeSafe", Preload );
            hookup( "ThreeCombo", Preload );
            hookup( "MasFemtest", Preload );
            hookup( "Adder", Preload );
            hookup( "Subber", Preload );
            hookup( "Multer", Preload );
            hookup( "Divider", Preload );

            hookup( "menu_file_newProject", clearing );
            hookup( "menu_edit_delete", clearing );
            hookup( "menu_edit_clear", clearing );
            hookup( "menu_edit_four", clearing );
            hookup( "menu_edit_real", clearing );

            hookup( "menu_file_save", saveLoad );
            hookup( "menu_file_load", saveLoad );
		}
	};

	return sys;
}() );



