/* monitor.js */

// The following comments are for JSLint
/*jslint nomen: true, white: true, vars: true */
/*global document, window, screen, console, M */

// This model creates a G.rand property with a private closure

G.monitor = ( function () {
	"use strict";
	var e;

	e = document.getElementById( "monitor" );
	e.style.display = "none";

	// Any property of <sys> becomes a public property of G.monitor

	var sys = {

		say : function ( str ) {
			var val;

			val = e.value;
			e.value = val + str;
		},

		clear : function () {
			e.value = "";
		},

		get : function () {
			return e.value;
		},

		show : function () {
			e.style.display = "block";
		},

		hide : function () {
			e.style.display = "none";
		},

		resize : function ( w ) {
			e.style.width = w + "px";
		}
	}

	return sys;
} () );
