/* pixi.js */

// The following comments are for JSLint
/*jslint nomen: true, white: true, vars: true */
/*global document, window, screen, console, M */

// This model creates a G.pixi property with a private closure

G.pixi = ( function () {
	"use strict";
	var renderer, stage, texture, current, action, amDragging, dragged, count, wheelList, nodeList, wireList, mode, xSize, ySize, xScale, yScale, xAdjust, yAdjust, movingBoard, oldPosition, lockBoard, fourBoards, movingDial, movingWheel, oldDialX;

    var board1, board2, board3, board4, source, storybox, storytext, storyeditor, holders, resultList, realism;

    var editing, editW, editL, enteredW, enteredL;

    var tutorialSave, tutorialCount, tutorialImg, tutorialBox, tutorialText, tutorialBack, tutorialNext;

	function animate()
    {
		requestAnimationFrame(animate);

		//wheel1.rotation += 0.01;

        count++;

        for(var i=0;i<nodeList.length;i++)
        {
            if(nodeList[i].custom.powered && nodeList[i].custom.myWheel>=0)
            {
                nodeList[i].rotation=count%360;
            }
            else
            {
                nodeList[i].rotation=0;
            }
        }

        if(mode===2 || mode===3 || (mode===4 && tutorialCount>=9))
        {
            for(var i=0;i<24;i++)
            {
                wheelList[i].custom.myPointer.rotation=(count%360)/2;
            }
        }

        if(action===1)
        {
            current.rotation=Math.sin(count*0.07);
            for(var i=0;i<wireList.length;i++)
            {
                if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                {
                    wireList[i].scale.x=(0.05+0.02*Math.sin(count*0.07))*xScale;
                    wireList[i].scale.y=(0.05+0.02*Math.sin(count*0.07))*yScale;
                }
            }
        }
        else if(amDragging)
        {
            dragged.custom.nodeOne.rotation=Math.sin(count*1);
            dragged.custom.nodeTwo.rotation=Math.cos(count*1);
        }

		renderer.render(stage);
	}

    function spawnWheels()
    {
        for(var i=0; i<24;i++)
        {

            //var i = wheelList.length;
            texture = PIXI.Texture.fromImage( 'img/gear.png' );

            var newWheel = new PIXI.Sprite( texture );
            newWheel.anchor.x = 0.5;
            newWheel.anchor.y = 0.5;
            // stage.addChild(newWheel);

            newWheel.custom = new Object();
            newWheel.custom.nodes = [ 16 ];
            newWheel.custom.slices = [ 16 ];
            newWheel.custom.letters = [ 16 ];

            for ( var j = 0; j < 16; j++ ) {
                newWheel.custom.nodes[ j ] = [ 4 ];
                newWheel.custom.nodes[ j ][ 0 ] = spawnNode( i, j, 0 );
                newWheel.custom.nodes[ j ][ 1 ] = spawnNode( i, j, 1 );
                newWheel.custom.nodes[ j ][ 2 ] = spawnNode( i, j, 2 );
                newWheel.custom.nodes[ j ][ 3 ] = spawnNode( i, j, 3 );

                //texture = PIXI.Texture.fromImage('img/Slice.svg');
                //newWheel.slices[i] = new PIXI.Sprite(texture);
                //newWheel.slices[i].anchor.x = 0.5;
                //newWheel.slices[i].anchor.y = 0.5;
                //newWheel.slices[i].position.x = wheelX + (5*Math.sin(Math.PI/8*i))*xScale;
                //newWheel.slices[i].position.y = wheelY + (5*Math.cos(Math.PI/8*i))*yScale;
                //newWheel.slices[i].scale.x=0.99*xScale;
                //newWheel.slices[i].scale.y=0.99*yScale;
                //newWheel.slices[i].rotation=-Math.PI/8*(i+4);
                //newWheel.slices[i].interactive = true;
                //newWheel.slices[i].on('mouseover', enterLine);
                //newWheel.slices[i].on('mouseout', exitLine);
                //newWheel.slices[i].on('mousedown', clickLine);
                //stage.addChild(newWheel.slices[i]);

                newWheel.custom.slices[ j ] = new PIXI.Graphics();
                newWheel.custom.slices[ j ].custom = new Object();
                newWheel.custom.slices[ j ].custom.fillColor = 0x00FF00;
                if ( j === 8 ) {
                    newWheel.custom.slices[ j ].custom.fillColor = 0xFF00FF;
                }
                newWheel.custom.slices[ j ].interactive = true;
                newWheel.custom.slices[ j ].on( 'mouseover', enterLine );
                newWheel.custom.slices[ j ].on( 'mouseout', exitLine );
                newWheel.custom.slices[ j ].on( 'mousedown', clickLine );
                newWheel.custom.slices[ j ].alpha = 0.7;

                newWheel.custom.slices[ j ].custom.myWheel = i;
                newWheel.custom.slices[ j ].custom.myLine = j;
                newWheel.custom.slices[ j ].custom.myDescription = "- this is wheel #" + i + ", line #" + j;

                newWheel.custom.letters[ j ] = new PIXI.Text( '-' );
            }

            newWheel.custom.myDescription = "- this is wheel #" + i + ", the center";

            newWheel.custom.myTextId = G.text.create( 4 );

            //G.monitor.say(" next wheel: " +i+ "  box_"+(i));
            //newWheel.custom.myTextId = G.text.create( 4, function () {G.text.edit( "box_"+(i), true );} );
            G.text.set( newWheel.custom.myTextId, newWheel.custom.myDescription );

            newWheel.custom.myCenter = new PIXI.Graphics();
            newWheel.custom.myCenter.interactive = true;
            newWheel.custom.myCenter.on( 'mouseover', enterDial );
            newWheel.custom.myCenter.on( 'mouseout', exitDial );
            newWheel.custom.myCenter.on( 'mousedown', clickDial );
            newWheel.custom.myCenter.custom = new Object();
            newWheel.custom.myCenter.custom.myWheel = i;

            texture = PIXI.Texture.fromImage( 'img/256.png' );
            newWheel.custom.myPointer = new PIXI.Sprite( texture );
            newWheel.custom.myPointer.anchor.x = 0.5;
            newWheel.custom.myPointer.anchor.y = 0.5;

            newWheel.custom.myPointer.custom = new Object();
            newWheel.custom.myPointer.custom.currentPos = 8;

            texture = PIXI.Texture.fromImage( 'img/DialPhoto.png' );
            var newDial = new PIXI.Sprite( texture );
            newDial.anchor.x = 0.5;
            newDial.anchor.y = 0.5;
            newDial.interactive = true;
            newDial.on('mousedown', realDialDragStart);
            newDial.on('mouseup', realDialDragEnd);
            newDial.on('mouseupoutside', realDialDragEnd);
            newDial.on('mousemove', realDialDragMove);

            newDial.custom=new Object();
            newDial.custom.myWheel=i;

            newWheel.custom.myRealDial=newDial;



            wheelList.push( newWheel );
        }
    }

    function spawnNode (wheelNum, lineNum, rankNum)
    {
        texture = PIXI.Texture.fromImage('img/256.png');

        var newNode = new PIXI.Sprite(texture);
        newNode.anchor.x = 0.5;
        newNode.anchor.y = 0.5;
        newNode.interactive = true;
        newNode.on('mousedown', clickNode);

        newNode.custom=new Object();
        newNode.custom.myWheel=wheelNum;
        newNode.custom.myLine=lineNum;
        newNode.custom.myRank=rankNum;
        newNode.custom.friends=[];
        newNode.custom.isSource=false;
        newNode.custom.powered=false;

        stage.addChild(newNode);

        nodeList.push(newNode);

        return newNode;
    }

    function enterStoryBox(event)
    {
        if(mode===2 || mode===3 || mode==4)
        {
            enteredW=-15;
            enteredL=-15;
            if(!editing)
            {
                G.text.show(storyeditor);
                for(var i=0;i<24;i+=2)
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }
        }
    }

    function exitStoryBox(event)
    {
        if(mode===2 || mode===3 || mode==4)
        {
            if(enteredW===-15 && enteredL===-15 && !editing)
            {
                G.text.hide(storyeditor);
                if(mode!=4)
                {
                    var iMax=24;
                    if(!fourBoards)
                    {
                        iMax=6;
                    }
                    for(var i=0;i<iMax;i+=2)
                    {
                        G.text.show(wheelList[i].custom.myTextId);
                    }
                }
                else if(tutorialCount>=13)
                {
                    G.text.show(wheelList[0].custom.myTextId);
                }
                else
                {
                    for(var i=0;i<4;i+=2)
                    {
                        G.text.show(wheelList[i].custom.myTextId);
                    }
                }
                enteredW=-666;
                enteredL=-666;
            }
        }
    }

    function clickStoryBox (event)
    {
        if(mode===2)
        {
            if(action===2)
            {
                G.text.set(storyeditor, "- Write a description for this creation here");
            }
            else
            {
                if(editing)
                {
                    G.pixi.stopEditing();
                    return;
                }

                G.text.edit(storyeditor, true);
            }
        }
    }

    function enterDial(event)
    {
        if(mode===2 || (mode===3 && wheelList[this.custom.myWheel].custom.myDescription.substr(0, 1)!="-"))
        {
            enteredW=this.custom.myWheel;
            enteredL=-1;
            if(!editing)
            {
                G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.myDescription);
            }
        }
    }

    function exitDial(event)
    {
        if(mode===2 || (mode===3 && wheelList[this.custom.myWheel].custom.myDescription.substr(0, 1)!="-"))
        {
            if(enteredW===this.custom.myWheel && enteredL===-1 && !editing)
            {
                G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.myDescription);
                enteredW=-666;
                enteredL=-666;
            }
        }
    }

    function clickDial (event)
    {
        if(mode===2)
        {
            if(action===2)
            {
                wheelList[this.custom.myWheel].custom.myDescription="- as the first character will result in a blank description in play mode";
            }
            else
            {
                //TODO: make a tooltip pop up to write in. currently just takes whatevers in the monitor. OR DO WE?

                G.monitor.say(" Clicked a dial?");
                //board.alpha=0;
            }
        }
        else if (mode === 3)
        {
            //var newPosition = event.data.getLocalPosition(this.parent);

            incrementDial(this.custom.myWheel);

            var looping=15;
            var thisWheel = wheelList[this.custom.myWheel];
            while(looping>0 && thisWheel.custom.letters[thisWheel.custom.myPointer.custom.currentPos].text=="-")
            {
                incrementDial(this.custom.myWheel);
                looping--;
            }
        }
    }

    function wireDragStart(event)
    {
        if(action===2)
        {
            severNodes(this.custom.nodeOne, this.custom.nodeTwo);
        }
        else
        {
            this.data = event.data;
            this.custom.dragging = true;
            amDragging=true;
            dragged=this;
        }
    }

    function wireDragEnd(event)
    {
        this.custom.data = null;
        this.custom.dragging = false;

        amDragging=false;
        this.custom.nodeOne.rotation=0;
        this.custom.nodeTwo.rotation=0;

        G.pixi.mode(mode);

        //this.myLine.moveTo(this.nodeOne.position.x, this.nodeOne.position.y);

        //this.myLine.quadraticCurveTo(
        //    this.position.x, this.position.y,
        //    this.nodeTwo.position.x, this.nodeTwo.position.y);
    }

    function wireDragMove(event)
    {
        if (this.custom.dragging)
        {
            var newPosition = this.data.getLocalPosition(this.parent);
            this.position.x = newPosition.x;
            this.position.y = newPosition.y;
            this.custom.trueX=(newPosition.x + xAdjust)/xScale;
            this.custom.trueY=(newPosition.y + yAdjust)/yScale;

            this.custom.myLine.clear();
            stage.removeChild(this.custom.myLine);


            this.custom.myLine = new PIXI.Graphics();
            stage.addChild(this.custom.myLine);


            this.custom.myLine.lineStyle(this.custom.myLength, this.custom.myColor, 1);

            this.custom.myLine.moveTo(this.custom.nodeOne.position.x, this.custom.nodeOne.position.y);

            this.custom.myLine.quadraticCurveTo(
                (this.position.x - (this.custom.nodeOne.position.x/4) - this.custom.nodeTwo.position.x/4)*2,  (this.position.y - (this.custom.nodeOne.position.y/4) - this.custom.nodeTwo.position.y/4)*2,
                this.custom.nodeTwo.position.x, this.custom.nodeTwo.position.y);
        }
    }

    function enterLine(event)
    {
        if(mode===2 || mode==3 || mode==4)
        {
            this.alpha=1;
            enteredW=this.custom.myWheel;
            enteredL=this.custom.myLine;
            if(!editing && (mode!=3 || this.custom.myDescription.substr(0,1)!="-"))
            {
                G.text.set(wheelList[this.custom.myWheel].custom.myTextId, this.custom.myDescription);
            }
            else if(mode===3 || (this.custom.myDescription.substr(0,1)==="-" && !editing))
            {
                G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.myDescription);
            }
        }
    }

    function exitLine(event)
    {
        if(mode===2 || mode===3 || mode==4)
        {
            this.alpha = 0.7;
            if (enteredW === this.custom.myWheel && enteredL === this.custom.myLine)
            {
                enteredW = -666;
                enteredL = -666;
                if (!editing && (mode!=3 || this.custom.myDescription.substr(0,1)!="-"))
                {
                    G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.myDescription);
                }
            }
        }
    }

    function clickLine(event)
    {
       // var newPosition = event.data.getLocalPosition(this.parent);
      //  G.tooltip.show( newPosition.x, newPosition.y, "?", "This is a question mark", false );

        //TODO: when clicking a line, a tooltip should pop up to edit. For now, it takes input from monitor

        if(mode===2)
        {
            if(action===2)
            {
                wheelList[this.custom.myWheel].custom.letters[this.custom.myLine].text="?";
                this.custom.myDescription="New Line";
            }
            else
            {
                if(editing)
                {
                    G.pixi.stopEditing();
                    return;
                }

                G.text.edit(wheelList[this.custom.myWheel].custom.myTextId, true);
            }
        }
        else if(mode===3)
        {
            //TODO: this should probably be done differently
            while(wheelList[this.custom.myWheel].custom.myPointer.custom.currentPos!==this.custom.myLine)
            {
                incrementDial(this.custom.myWheel);
            }
        }
    }

    function boardDragStart(event)
    {
        if(!lockBoard && fourBoards)
        {
            movingBoard=true;
            oldPosition=0;
        }
    }

    function boardDragEnd(event)
    {
        if(!lockBoard && fourBoards)
        {
            movingBoard=false;
            oldPosition=0;

            if(xAdjust<=0)
            {
                xAdjust=0;
            }
            else if(xAdjust>=950)
            {
                xAdjust=950;
            }

            if(yAdjust<=0)
            {
                yAdjust=0;
            }
            else if(yAdjust>=685)
            {
                yAdjust=685;
            }


            G.pixi.resize(xSize, ySize);
        }
    }

    function boardDragMove(event)
    {
        if(movingBoard)
        {
            var newPosition = event.data.getLocalPosition(this.parent);
            if(oldPosition===0)
            {
                oldPosition=newPosition;
            }

            xAdjust-=newPosition.x-oldPosition.x;
            yAdjust-=newPosition.y-oldPosition.y;

            if(xAdjust<=-50)
            {
                xAdjust=-50;
            }
            else if(xAdjust>=1000)
            {
                xAdjust=1000;
            }

            if(yAdjust<=-50)
            {
                yAdjust=-50;
            }
            else if(yAdjust>=735)
            {
                yAdjust=735;
            }

            oldPosition=newPosition;

            G.pixi.resize(xSize, ySize);
        }
    }


    function realDialDragStart(event)
    {
        if(realism)
        {
            movingDial=true;
            movingWheel=this.custom.myWheel;
            oldPosition = event.data.getLocalPosition(this.parent);

            var oldRot=(Math.atan2(oldPosition.x-wheelList[this.custom.myWheel].position.x, (oldPosition.y-wheelList[this.custom.myWheel].position.y))-Math.PI)*-1;

            var oldRotation=((Math.floor(((oldRot*360 + 22*Math.PI)/22.5)/(Math.PI*2))-24)*-1)%16;

            this.rotation=oldRot;

            if(oldRotation!=wheelList[this.custom.myWheel].custom.myPointer.custom.currentPos)
            {
                while(wheelList[this.custom.myWheel].custom.myPointer.custom.currentPos!=oldRotation)
                {
                    decrementDial(this.custom.myWheel);
                }
            }

            G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.slices[oldRotation].custom.myDescription);
        }
    }

    function realDialDragEnd(event)
    {
        if(movingDial)
        {
            movingDial=false;

            G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.myDescription);

            //G.pixi.resize(xSize, ySize);
        }
    }

    function realDialDragMove(event)
    {
        if(realism && movingDial && movingWheel==this.custom.myWheel)
        {
            /*
            var newPosition = event.data.getLocalPosition(this.parent);

            var adjustment=newPosition.x-oldDialX;

            var oldRotation=Math.floor(((this.rotation*360 + 22*Math.PI)/22.5)/(Math.PI*2));

            this.rotation+=adjustment*0.007;

            var newRotation=Math.floor(((this.rotation*360 + 22*Math.PI)/22.5)/(Math.PI*2));
            */

            var newPosition = event.data.getLocalPosition(this.parent);

            var oldRot=(Math.atan2(oldPosition.x-wheelList[this.custom.myWheel].position.x, (oldPosition.y-wheelList[this.custom.myWheel].position.y))-Math.PI)*-1;
            var newRot=(Math.atan2(newPosition.x-wheelList[this.custom.myWheel].position.x, (newPosition.y-wheelList[this.custom.myWheel].position.y))-Math.PI)*-1;

            this.rotation=newRot;

            var oldRotation=((Math.floor(((oldRot*360 + 22*Math.PI)/22.5)/(Math.PI*2))-24)*-1)%16;
            var newRotation=((Math.floor(((newRot*360 + 22*Math.PI)/22.5)/(Math.PI*2))-24)*-1)%16;


            //G.monitor.clear();
            //G.monitor.say(newRotation);

            if(oldRotation!=newRotation)
            {
                if(oldRotation>newRotation)
                {
                    while(wheelList[this.custom.myWheel].custom.myPointer.custom.currentPos!=newRotation)
                    {
                        decrementDial(this.custom.myWheel);
                    }
                }
                else
                {
                    while(wheelList[this.custom.myWheel].custom.myPointer.custom.currentPos!=newRotation)
                    {
                        incrementDial(this.custom.myWheel);
                    }
                }
                //G.monitor.say(oldRotation + " ");
                G.text.set(wheelList[this.custom.myWheel].custom.myTextId, wheelList[this.custom.myWheel].custom.slices[newRotation].custom.myDescription);
            }

            wheelList[this.custom.myWheel].custom.myPointer.position.x=wheelList[this.custom.myWheel].position.x + (260*Math.sin(this.rotation))*xScale;
            wheelList[this.custom.myWheel].custom.myPointer.position.y=wheelList[this.custom.myWheel].position.y - (260*Math.cos(-this.rotation))*yScale;

            oldPosition=newPosition;

         //   G.pixi.resize(xSize, ySize);
        }
    }


    function incrementDial(pickedWheel)
    {
        var thisWheel = wheelList[pickedWheel];

        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].custom.fillColor=0x00FF00;
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].clear();
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].beginFill(0x00FF00);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].moveTo(thisWheel.position.x, thisWheel.position.y);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.50)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].endFill();
        stage.addChild(thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos]);

        thisWheel.custom.myPointer.custom.currentPos+=1;
        if(thisWheel.custom.myPointer.custom.currentPos===16)
        {
            thisWheel.custom.myPointer.custom.currentPos=0;
        }

        thisWheel.custom.myPointer.position.x=thisWheel.position.x + (260*Math.sin(Math.PI/8*thisWheel.custom.myPointer.custom.currentPos))*xScale;
        thisWheel.custom.myPointer.position.y=thisWheel.position.y + (260*Math.cos(Math.PI/8*thisWheel.custom.myPointer.custom.currentPos))*yScale;

        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].custom.fillColor=0xFF00FF;
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].clear();
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].beginFill(0xFF00FF);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].moveTo(thisWheel.position.x, thisWheel.position.y);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.50)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].endFill();

        var should01 = (thisWheel.custom.nodes[15][0].custom.friends.indexOf(thisWheel.custom.nodes[15][1]) != -1);
        var should12 = (thisWheel.custom.nodes[15][1].custom.friends.indexOf(thisWheel.custom.nodes[15][2]) != -1);
        var should23 = (thisWheel.custom.nodes[15][2].custom.friends.indexOf(thisWheel.custom.nodes[15][3]) != -1);
        var next01 = false;
        var next12 = false;
        var next23 = false;

        for (var i = 0; i < 16; i++)
        {
            var node0 = thisWheel.custom.nodes[i][0];
            var node1 = thisWheel.custom.nodes[i][1];
            var node2 = thisWheel.custom.nodes[i][2];
            var node3 = thisWheel.custom.nodes[i][3];

            if (node0.custom.friends.indexOf(node1) != -1)
            {
                next01 = true;

                severNodes(node0, node1);
            }

            if (node1.custom.friends.indexOf(node2) != -1)
            {
                next12 = true;

                severNodes(node1, node2);
            }

            if (node2.custom.friends.indexOf(node3) != -1)
            {
                next23 = true;

                severNodes(node2, node3);
            }

            if (should01)
            {
                connectNodes(node0, node1);
            }

            if (should12)
            {
                connectNodes(node1, node2);
            }

            if (should23)
            {
                connectNodes(node2, node3);
            }

            should01 = next01;
            should12 = next12;
            should23 = next23;
            next01 = false;
            next12 = false;
            next23 = false;
        }

        G.pixi.mode(3);
    }

    function decrementDial(pickedWheel)
    {
        var thisWheel = wheelList[pickedWheel];

        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].custom.fillColor=0x00FF00;
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].clear();
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].beginFill(0x00FF00);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].moveTo(thisWheel.position.x, thisWheel.position.y);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.50)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].endFill();
        stage.addChild(thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos]);

        thisWheel.custom.myPointer.custom.currentPos-=1;
        if(thisWheel.custom.myPointer.custom.currentPos===-1)
        {
            thisWheel.custom.myPointer.custom.currentPos=15;
        }

        thisWheel.custom.myPointer.position.x=thisWheel.position.x + (260*Math.sin(Math.PI/8*thisWheel.custom.myPointer.custom.currentPos))*xScale;
        thisWheel.custom.myPointer.position.y=thisWheel.position.y + (260*Math.cos(Math.PI/8*thisWheel.custom.myPointer.custom.currentPos))*yScale;

        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].custom.fillColor=0xFF00FF;
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].clear();
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].beginFill(0xFF00FF);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].moveTo(thisWheel.position.x, thisWheel.position.y);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos+0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].lineTo(thisWheel.position.x + (240*Math.sin(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.50)))*xScale, thisWheel.position.y + (240*Math.cos(Math.PI/8*(thisWheel.custom.myPointer.custom.currentPos-0.48)))*yScale);
        thisWheel.custom.slices[thisWheel.custom.myPointer.custom.currentPos].endFill();

        var should01 = (thisWheel.custom.nodes[0][0].custom.friends.indexOf(thisWheel.custom.nodes[0][1]) != -1);
        var should12 = (thisWheel.custom.nodes[0][1].custom.friends.indexOf(thisWheel.custom.nodes[0][2]) != -1);
        var should23 = (thisWheel.custom.nodes[0][2].custom.friends.indexOf(thisWheel.custom.nodes[0][3]) != -1);
        var next01 = false;
        var next12 = false;
        var next23 = false;

        for (var i = 15; i >=0; i--)
        {
            var node0 = thisWheel.custom.nodes[i][0];
            var node1 = thisWheel.custom.nodes[i][1];
            var node2 = thisWheel.custom.nodes[i][2];
            var node3 = thisWheel.custom.nodes[i][3];

            if (node0.custom.friends.indexOf(node1) != -1)
            {
                next01 = true;

                severNodes(node0, node1);
            }

            if (node1.custom.friends.indexOf(node2) != -1)
            {
                next12 = true;

                severNodes(node1, node2);
            }

            if (node2.custom.friends.indexOf(node3) != -1)
            {
                next23 = true;

                severNodes(node2, node3);
            }

            if (should01)
            {
                connectNodes(node0, node1);
            }

            if (should12)
            {
                connectNodes(node1, node2);
            }

            if (should23)
            {
                connectNodes(node2, node3);
            }

            should01 = next01;
            should12 = next12;
            should23 = next23;
            next01 = false;
            next12 = false;
            next23 = false;
        }

        G.pixi.mode(3);
    }

    function rewire()
    {
        for(var i=0;i<wireList.length;i++)
        {
            var curWire=wireList[i];

            curWire.custom.myLine.clear();
            stage.removeChild(curWire.custom.myLine);
            stage.addChild(curWire.custom.myLine);

            if(curWire.custom.nodeOne.custom.myLine===curWire.custom.nodeTwo.custom.myLine && curWire.custom.nodeOne.custom.myWheel===curWire.custom.nodeTwo.custom.myWheel)
            {
                if(curWire.custom.nodeOne.custom.powered)
                {
                    curWire.custom.myLength=5;
                    curWire.custom.myColor=0xFFFF00;
                    curWire.custom.myLine.lineStyle(5, 0xef7b18, 1);
                }
                else
                {
                    curWire.custom.myLength=4;
                    curWire.custom.myColor=0xFF0000;
                    curWire.custom.myLine.lineStyle(4, 0x49311c, 1);
                }
                curWire.custom.myLine.moveTo(curWire.custom.nodeOne.position.x, curWire.custom.nodeOne.position.y);
                curWire.custom.myLine.lineTo(curWire.custom.nodeTwo.position.x, curWire.custom.nodeTwo.position.y);
            }
            else
            {
                if(curWire.custom.nodeOne.custom.powered)
                {
                    curWire.custom.myLength=5;
                    curWire.custom.myColor=0xFFFF00;
                    curWire.custom.myLine.lineStyle(5, 0xFFFF00, 1);
                }
                else
                {
                    curWire.custom.myLength=2;
                    curWire.custom.myColor=0xFF0000;
                    curWire.custom.myLine.lineStyle(2, 0xFF0000, 1);

                }
                curWire.custom.myLine.moveTo(curWire.custom.nodeOne.position.x, curWire.custom.nodeOne.position.y);

                curWire.custom.myLine.quadraticCurveTo(
                    (curWire.position.x - (curWire.custom.nodeOne.position.x/4) - curWire.custom.nodeTwo.position.x/4)*2, (curWire.position.y - (curWire.custom.nodeOne.position.y/4) - curWire.custom.nodeTwo.position.y/4)*2,
                    curWire.custom.nodeTwo.position.x, curWire.custom.nodeTwo.position.y);
            }
        }
    }

    function isStillPowered(testNode)
    {
        if(testNode.custom.isSource)
        {
            return true;
        }

        var checked=[];
        var checking=[];
        checking.push(testNode);

        while(checking.length!=0)
        {
            var currentNode=checking.shift();
            checked.push(currentNode);
            for(var i=0;i<currentNode.custom.friends.length;i++)
            {
                var otherNode=currentNode.custom.friends[i];
                if(otherNode.custom.isSource)
                {
                    return true;
                }
                else if(checked.indexOf(otherNode)==-1)
                {
                    checking.push(otherNode);
                }
            }
        }

        return false;
    }

    function toggle(testNode)
    {
        testNode.custom.powered=!testNode.custom.powered;

        if(testNode.custom.myWheel<=-1)
        {
            if(testNode.custom.powered)
            {
                texture = PIXI.Texture.fromImage('img/Bulb On.svg');
            }
            else
            {
                texture = PIXI.Texture.fromImage('img/Bulb Off.svg');
            }
            testNode.texture=texture;
        }

        for(var i=0; i<testNode.custom.friends.length;i++)
        {
            if(testNode.custom.friends[i].custom.powered!==testNode.custom.powered)
            {
                toggle(testNode.custom.friends[i]);
            }
        }
    }

    function connectNodes(node1, node2)
    {
        if(node1.custom.friends.indexOf(node2)!==-1)
        {
            return;
        }

        node1.custom.friends.push(node2);
        node2.custom.friends.push(node1);


        texture = PIXI.Texture.fromImage('img/wire.png');

        var newWire = new PIXI.Sprite(texture);
        newWire.anchor.x = 0.5;
        newWire.anchor.y = 0.5;
        newWire.scale.x=0.03*xScale;
        newWire.scale.y=0.03*yScale;
        newWire.interactive = true;
        newWire.buttonMode = true;
        newWire.on('mousedown', wireDragStart);
        newWire.on('mouseup', wireDragEnd);
        newWire.on('mouseupoutside', wireDragEnd);
        newWire.on('mousemove', wireDragMove);

        newWire.custom=new Object();
        newWire.custom.dragging=false;
        newWire.custom.data=null;
        newWire.custom.nodeOne=node1;
        newWire.custom.nodeTwo=node2;
        newWire.custom.doShow=false;

        if(node1.custom.myWheel===node2.custom.myWheel && (node1.custom.myLine===node2.custom.myLine || (node1.custom.myRank===node2.custom.myRank && (node1.custom.myLine===node2.custom.myLine-1 || node1.custom.myLine===node2.custom.myLine+1 || node1.custom.myLine===node2.custom.myLine+15 || node1.custom.myLine===node2.custom.myLine-15))))
        {
            newWire.position.x=(node1.position.x+node2.position.x)/2;
            newWire.position.y=(node1.position.y+node2.position.y)/2;
        }
        else
        {
            newWire.custom.doShow=true;
            newWire.position.x = (node1.position.x+node2.position.x)/2;
            newWire.position.y = ((node2.position.y+node1.position.y)/2)+(Math.min(900*yScale, ((node2.position.y+node1.position.y)/2)+200)-((node2.position.y+node1.position.y)/2))/4;
            stage.addChild(newWire);
        }

        newWire.custom.trueX=(newWire.position.x + xAdjust)/xScale;
        newWire.custom.trueY=(newWire.position.y + yAdjust)/yScale;

        wireList.push(newWire);

        newWire.custom.myLine = new PIXI.Graphics();
        stage.addChild(newWire.custom.myLine);
        newWire.custom.myLength=10;
        newWire.custom.myColor=0xFF0000;

        if(node1.custom.powered && !node2.custom.powered)
        {
            toggle(node2);
            rewire();
        }
        else if(!node1.custom.powered && node2.custom.powered)
        {
            toggle(node1);
            rewire();
        }
        else
        {
            if(node1.custom.myLine===node2.custom.myLine && node1.custom.myWheel===node2.custom.myWheel)
            {
                if(node1.custom.powered)
                {
                    newWire.custom.myLength=5;
                    newWire.custom.myColor=0xFFFF00;
                    newWire.custom.myLine.lineStyle(5, 0xef7b18, 1);
                }
                else
                {
                    newWire.custom.myLength=4;
                    newWire.custom.myColor=0x49311c;
                    newWire.custom.myLine.lineStyle(4, 0x49311c, 1);
                }

                newWire.custom.myLine.moveTo(node1.position.x, node1.position.y);

                newWire.custom.myLine.lineTo(node2.position.x, node2.position.y);
            }
            else
            {
                if(node1.custom.powered)
                {
                    newWire.custom.myLength=5;
                    newWire.custom.myColor=0xFFFF00;
                    newWire.custom.myLine.lineStyle(5, 0xFFFF00, 1);
                }
                else
                {
                    newWire.custom.myLength=2;
                    newWire.custom.myColor=0xFF0000;
                    newWire.custom.myLine.lineStyle(2, 0xFF0000, 1);
                }

                newWire.custom.myLine.moveTo(node1.position.x, node1.position.y);

                newWire.custom.myLine.quadraticCurveTo(
                    (newWire.position.x - (node1.position.x/4) - node2.position.x/4)*2, (newWire.position.y - (node1.position.y/4) - node2.position.y/4)*2,
                    node2.position.x, node2.position.y);
            }
        }
    }

    function severNodes(node1, node2)
    {
        if(node1.custom.friends.indexOf(node2)==-1) // If severing a line we're already connected to
        {
            return;
        }

        for(var i=0;i<wireList.length;i++)
        {
            if((wireList[i].custom.nodeOne===node2 && wireList[i].custom.nodeTwo===node1) || (wireList[i].custom.nodeOne===node1 && wireList[i].custom.nodeTwo===node2))
            {
                wireList[i].custom.myLine.clear();
                stage.removeChild(wireList[i].custom.myLine);

                stage.removeChild(wireList[i]);

                wireList.splice(i,1);
                break;
            }
        }

        node2.custom.friends.splice(node2.custom.friends.indexOf(node1),1);
        node1.custom.friends.splice(node1.custom.friends.indexOf(node2),1);

        if(node2.custom.powered)
        {
            var shouldRewire=false;
            if (!isStillPowered(node1))
            {
                toggle(node1);
                shouldRewire=true;
            }
            if (!isStillPowered(node2))
            {
                toggle(node2);
                shouldRewire=true;
            }

            if(shouldRewire)
            {
                rewire();
            }
        }
    }

    function enterNodeBox(event)
    {
        if(mode===2)
        {
            enteredW=this.custom.myWheel;
            enteredL=-666;
        }
    }

    function exitNodeBox(event)
    {
        if(mode===2)
        {
            enteredW=-666;
            enteredL=-666;
        }
    }

    function clickNode(event)
    {
        if(mode===3) // If playing the game and click a node for no reason
        {
            ;
        }
        else if(mode===2)
        {
            if(this.custom.myWheel<-1)
            {
                if(action===2)
                {
                    this.custom.myDescription="- this is light # "+this.custom.myWheel;
                }
                else
                {
                    this.custom.myDescription=G.monitor.get();
                }
            }
        }
        else if(action===2)
        {
            while(this.custom.friends.length!==0)
            {
                var nodeB=this.custom.friends[0];

                severNodes(this, nodeB);
            }
        }
        else if(action===0) // First selection
        {
            action=1;
            current = this;
            this.scale.x += 0.1*xScale;
            this.scale.y += 0.1*yScale;
        }
        else if(this===current || (this.custom.myWheel<0 && current.custom.myWheel<0)) // Undo the selection
        {
            action=0;
            current.scale.x -=0.1*xScale;
            current.scale.y -=0.1*yScale;
            current.rotation=0;
            for(var i=0;i<wireList.length;i++)
            {
                if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                {
                    wireList[i].scale.x=0.03*xScale;
                    wireList[i].scale.y=0.03*yScale;
                }
            }
        }
        else if(this.custom.myLine===current.custom.myLine && this.custom.myWheel===current.custom.myWheel) // If selecting a line
        {
            action=0;

            for(var i=0;i<wireList.length;i++)
            {
                if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                {
                    wireList[i].scale.x=0.03*xScale;
                    wireList[i].scale.y=0.03*yScale;
                }
            }

            current.scale.x -=0.1*xScale;
            current.scale.y -=0.1*yScale;
            current.rotation=0;

            if(this.custom.friends.indexOf(current)!=-1) // If severing a line we're already connected to
            {
                severNodes(current, this);
            }
            else // If connecting to a node we're not attached yet
            {
                if(this.custom.myRank!=current.custom.myRank-1 && this.custom.myRank!=current.custom.myRank+1) // IF one tried to connect non-adjacent nodes
                {
                    return;
                }
                else if(this.custom.myRank+current.custom.myRank===3) // if one tries to connect two nodes that are already connected to another node on that line
                {
                    if(wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][0].custom.friends.indexOf(wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][1])!=-1 ||
                        wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][2].custom.friends.indexOf(wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][3])!=-1)
                    {
                        return;
                    }
                }
                else if(wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][1].custom.friends.indexOf(wheelList[this.custom.myWheel].custom.nodes[this.custom.myLine][2])!=-1)
                {
                    return;
                }

                connectNodes(current, this);
            }
        }
        else // If connecting to another line
        {
            action=0;

            for(var i=0;i<wireList.length;i++)
            {
                if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                {
                    wireList[i].scale.x=0.03*xScale;
                    wireList[i].scale.y=0.03*yScale;
                }
            }

            current.scale.x -=0.1*xScale;
            current.scale.y -=0.1*yScale;
            current.rotation=0;

            if(this.custom.friends.indexOf(current)!=-1) // If severing a line we're already connected to
            {
                severNodes(current, this);
            }
            else // If connecting to a wire we're not attached yet
            {
                connectNodes(current, this);
            }
        }
    }

    function clickTutBox(event)
    {
        tutorialCount+=this.custom.upOrDown;
        tutorialRefresh();
    }

    function tutorialRefresh()
    {
        G.pixi.clearAll();

        if(tutorialCount<=1)
        {
            tutorialCount=1;

            G.text.set(tutorialText, "Welcome to the Braniac tutorial! Click the green next button to continue");

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.1;
            tutorialImg.scale.y=0.1;
            tutorialImg.position.x=1700*xScale;
            tutorialImg.position.y=700*yScale;
            tutorialImg.rotation=-1.57;

        }
        else if(tutorialCount===2)
        {
            G.text.set(tutorialText, "Braniac is one of the first computer thinking machines, an electric circuit that can be wired to give a number of outputs (Turning the result lights on and off) based on user input (turning the dial to one of the 16 possible positions).");

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.0;
            tutorialImg.scale.y=0.0;
        }
        else if(tutorialCount===3)
        { // source of all power: the battery. Anything that can trace a connection to the battery is powered on, and anything that can't is unpowered.
            G.text.set(tutorialText, "To understand how the wiring works for Braniac, we'll start with the naming scheme. A 'wheel' (also called 'dial') is composed of 16 'slices', each of which have 4 'nodes' in a line aiming out from the center. To the left, you see we currently have 4 wheels, each containing 64 'nodes'.");

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.1;
            tutorialImg.scale.y=0.1;
            tutorialImg.position.x=700*xScale;
            tutorialImg.position.y=300*yScale;
            tutorialImg.rotation=3.14;
        }
        else if(tutorialCount===4)
        {
            G.text.set(tutorialText, "In the center area, we have 10 'result' lights that can be powered on and off, and a 'battery' that powers on anything connected to it. You can't just directly connect the battery to the result lights, so you'll have to do it indirectly using 'nodes'.");

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.1;
            tutorialImg.scale.y=0.1;
            tutorialImg.position.x=850*xScale;
            tutorialImg.position.y=550*yScale;
            tutorialImg.rotation=1.57;
        }
        else if(tutorialCount===5)
        { // source of all power: the battery. Anything that can trace a connection to the battery is powered on, and anything that can't is unpowered.
            G.text.set(tutorialText, "Nodes can be connected to eachother by clicking on the two you want to connect. This creates a wire between the two, causing all nodes in the chain to share the same 'on or off' state. Wire can be moved by dragging their red centers wherever you want.");


            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[2][3], source);
            connectNodes(wheelList[0].custom.nodes[4][3], wheelList[2].custom.nodes[12][3]);
            connectNodes(wheelList[2].custom.nodes[1][3], wheelList[3].custom.nodes[6][3]);
            connectNodes(wheelList[1].custom.nodes[0][3], wheelList[3].custom.nodes[1][1]);
            connectNodes(wheelList[1].custom.nodes[5][3], wheelList[3].custom.nodes[11][3]);
            connectNodes(wheelList[0].custom.nodes[15][3], wheelList[1].custom.nodes[0][3]);
            connectNodes(wheelList[0].custom.nodes[13][2], wheelList[1].custom.nodes[13][1]);
            connectNodes(wheelList[1].custom.nodes[12][2], wheelList[1].custom.nodes[13][1]);
            connectNodes(wheelList[1].custom.nodes[13][0], wheelList[1].custom.nodes[13][1]);
            connectNodes(wheelList[1].custom.nodes[0][3], wheelList[1].custom.nodes[13][1]);

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.1;
            tutorialImg.scale.y=0.1;
            tutorialImg.position.x=680*xScale;
            tutorialImg.position.y=800*yScale;
            tutorialImg.rotation=1.57;
        }
        else if(tutorialCount===6)
        {
            G.text.set(tutorialText, "Nodes connected within the same 'slice' are special, in that their connection can be rotated around the circle in 'play mode', chaning the wiring scheme on the fly. They still act the same as regular wires, and we'll talk about how they move later.");

            connectNodes(wheelList[0].custom.nodes[8][3], wheelList[0].custom.nodes[8][2]);
            connectNodes(wheelList[0].custom.nodes[8][1], wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[5][2], wheelList[0].custom.nodes[5][1]);

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.1;
            tutorialImg.scale.y=0.1;
            tutorialImg.position.x=600*xScale;
            tutorialImg.position.y=300*yScale;
            tutorialImg.rotation=3.92;
        }
        else if(tutorialCount===7)
        {
            G.text.set(tutorialText, "The battery and lights can be clicked on to connect them to nodes as well. Any node or light with a chain of wires leading to the battery is powered on, and everything else is powered off.");

            connectNodes(source, wheelList[0].custom.nodes[9][3]);
            connectNodes(wheelList[0].custom.nodes[9][3], resultList[2]);
            connectNodes(wheelList[0].custom.nodes[9][3], wheelList[2].custom.nodes[5][1]);

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===8)
        {
            G.text.set(tutorialText, "This is the wiring system for the very first Geniac project, the 'Flashlight'. While the wiring is complete, its meaningless to the user if you don't know what the dial positions and result lights represent. To give these things names and meanings, we'll use 'Dials mode'.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            for(var i=0;i<4;i++)
            {
                stage.removeChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.removeChild(wheelList[i].custom.slices[j]);
                    stage.removeChild(wheelList[i].custom.letters[j]);
                }
                stage.removeChild(wheelList[i].custom.myCenter);
                G.text.hide(wheelList[i].custom.myTextId);
            }

            stage.removeChild(storybox);
            stage.removeChild(storytext);

            for(var i=0; i<5; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===9)
        {
            G.text.set(tutorialText, "In Dials mode, we see an outline of every slice, a label for every result light, a story box for explaining the project's backstory, and a text box at the center of every wheel. We can't connect nodes or make new wires in this mode, but we can still move existing wires by dragging them.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    stage.addChild(wheelList[i].custom.letters[j]);
                }
                stage.addChild(wheelList[i].custom.myCenter);
                G.text.show(wheelList[i].custom.myTextId);
            }

            stage.addChild(storybox);
            stage.addChild(storytext);

            for(var i=0; i<5; i++)
            {
                G.text.show(resultList[i].custom.myTextId);
                stage.addChild(resultList[i].custom.myBox);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===10)
        {
            G.text.set(tutorialText, "The center text boxes by default show the description for each wheel, and you can see the description for each slice by hovering your mouse over it. Hovering over the story box will bring up the story description as well.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    stage.addChild(wheelList[i].custom.letters[j]);
                }
                stage.addChild(wheelList[i].custom.myCenter);
                G.text.show(wheelList[i].custom.myTextId);
            }

            stage.addChild(storybox);
            stage.addChild(storytext);

            for(var i=0; i<5; i++)
            {
                G.text.show(resultList[i].custom.myTextId);
                stage.addChild(resultList[i].custom.myBox);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===11)
        {
            G.text.set(tutorialText, "In the real Dials mode, you can click on the object you want to edit and an editable text box will pop up. Anything you change in the text box will automatically be saved, and clicking on anything else or pressing enter will stop the editing.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    stage.addChild(wheelList[i].custom.letters[j]);
                }
                stage.addChild(wheelList[i].custom.myCenter);
                G.text.show(wheelList[i].custom.myTextId);
            }

            stage.addChild(storybox);
            stage.addChild(storytext);

            for(var i=0; i<5; i++)
            {
                G.text.show(resultList[i].custom.myTextId);
                stage.addChild(resultList[i].custom.myBox);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===12)
        {
            G.text.set(tutorialText, "When everything you want described is finished, and all the wiring is correct, you can try out your project in play mode. You can switch between modes at any time and edit whatever you wish, of course, though play mode is mostly for testing when the other two are finished.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    stage.addChild(wheelList[i].custom.letters[j]);
                }
                stage.addChild(wheelList[i].custom.myCenter);
                G.text.show(wheelList[i].custom.myTextId);
            }

            stage.addChild(storybox);
            stage.addChild(storytext);

            for(var i=0; i<5; i++)
            {
                G.text.show(resultList[i].custom.myTextId);
                stage.addChild(resultList[i].custom.myBox);
            }

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===13)
        {
            G.text.set(tutorialText, "Play mode looks similar to Dials mode, and hovering over slices and text boxes still show the description for that object. Clicking on slices will now rotate that wheel's pointer to whichever slice you selected, rearranging the wiring diagram.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===14)
        {
            G.text.set(tutorialText, "Only descriptions that don't start with the '-' character will be shown, so only the relevant parts of the project you manually edited in Dials mode will be of use in Play mode. You can still rotate the dial to unmarked slices, and lights without a label can still be turned on and off.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===15)
        {
            G.text.set(tutorialText, "Remember the odd colored wires we talked about before, for connecting nodes in the same slice? When the wheel is rotated, only those wires move with the wheel, while the rest remain where they are. This can sever old connections or create new ones, and some wires may gain or lose power as a result.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            connectNodes(wheelList[2].custom.nodes[8][2], wheelList[2].custom.nodes[8][3]);
            connectNodes(wheelList[2].custom.nodes[6][2], wheelList[2].custom.nodes[6][3]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    if(!(i==2 && (j=== 8 || j=== 7 || j=== 6)))
                    {
                        stage.addChild(wheelList[i].custom.slices[j]);
                        if (wheelList[i].custom.letters[j].text != "-")
                        {
                            stage.addChild(wheelList[i].custom.letters[j]);
                        }
                        else
                        {
                            stage.removeChild(wheelList[i].custom.letters[j]);
                        }
                    }
                    else
                    {
                        G.monitor.say("stop bein dumb");
                        stage.removeChild(wheelList[i].custom.slices[j]);
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.scale.x=0.07;
            tutorialImg.scale.y=0.07;
            tutorialImg.position.x=1030*xScale;
            tutorialImg.position.y=120*yScale;
            tutorialImg.rotation=0.75;
        }
        else if(tutorialCount===16)
        {
            G.text.set(tutorialText, "With the right wiring, you can make certain lights turn on and off when that wheel's pointer is at certain slices. This corresponds to choosing a different option at that wheel, and often means a different result light pops up.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount===17)
        {
            G.text.set(tutorialText, "When you're finished with a project, you can save it by pressing the save button below, where a code is placed in the lower text box. To load projects, put a project code in the same box and press load. To start from scratch, press the 'Clear All' button, or turn on clear mode to delete wires / descriptions instead of edit them. ");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
        else if(tutorialCount>=18)
        {
            tutorialCount=18;

            G.text.set(tutorialText, "This simulation comes with all of the original Geniac, Braniac, and Tiniac projects. You can load them up by selecting them from the drop down menu, and play or edit them however you want. Saving won't change the original projects, but instead give you a new code based on your changes.");

            connectNodes(source, wheelList[0].custom.nodes[8][0]);
            connectNodes(wheelList[0].custom.nodes[8][0], wheelList[0].custom.nodes[8][1]);
            connectNodes(wheelList[0].custom.nodes[8][1], resultList[4]);

            wheelList[0].custom.myDescription="State of the switch";
            G.text.set(wheelList[0].custom.myTextId, "State of the switch");
            wheelList[0].custom.letters[8].text="O";
            wheelList[0].custom.slices[8].custom.myDescription="On";
            wheelList[0].custom.letters[7].text="o";
            wheelList[0].custom.slices[7].custom.myDescription="off";
            resultList[4].custom.myDescription="Light is shining";
            G.text.set(resultList[4].custom.myTextId, "Light is shining");
            G.text.set(storyeditor, "A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.");

            for(var i=0; i<3; i++)
            {
                G.text.hide(resultList[i].custom.myTextId);
                stage.removeChild(resultList[i].custom.myBox);
            }

            G.text.show(resultList[4].custom.myTextId);
            stage.removeChild(resultList[4].custom.myBox);


            for(var i=0;i<4;i++)
            {
                stage.addChild(wheelList[i].custom.myPointer);

                for(var j=0;j<16;j++)
                {
                    stage.addChild(wheelList[i].custom.slices[j]);
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                }
                stage.addChild(wheelList[i].custom.myCenter);
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    G.text.show(wheelList[i].custom.myTextId);
                }
                else
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
            }

            for(var i=0;i<wireList.length;i++)
            {
                stage.removeChild(wireList[i]);
            }

            texture = PIXI.Texture.fromImage('img/arrow.png');
            tutorialImg.texture=texture;
            tutorialImg.position.x=-100;
            tutorialImg.position.y=-100;
        }
    }

	var sys = {

        resize : function (width, height)
        {
            var XSIZE = 1920;
            var YSIZE = 1294;

            xSize = width;
            ySize = height;
            //ySize = Math.floor( width / 2.01 );
            //ySize = Math.floor( width / 2.5 );

            renderer.view.style.width = xSize;// + "px";
            renderer.view.style.height = ySize;// + "px";

            renderer.view.marginTop = "-" + Math.floor( height / 2 ) + "px";

            //this part adjusts the ratio

            renderer.resize( xSize, ySize );

        //    xScale=xSize/1920;
        //    yScale=ySize/955;
            xScale=xSize/XSIZE;
            yScale=ySize/YSIZE;

            var boardScale=1.3;
            if(realism)
            {
                boardScale=0.42
            }

            board1.position.x = 0.5*xSize - xAdjust;
            board1.position.y = 0.5*ySize - yAdjust;
            board1.scale.x=boardScale*xScale;
            board1.scale.y=boardScale*yScale;

            //board2.position.x = 1.61*xSize - xAdjust;
            board2.position.x = 1.404*xSize - xAdjust;
            board2.position.y = 0.5*ySize - yAdjust;
            board2.scale.x=boardScale*xScale;
            board2.scale.y=boardScale*yScale;

            board3.position.x = 0.5*xSize - xAdjust;
            board3.position.y = 1.464*ySize - yAdjust;
            board3.scale.x=boardScale*xScale;
            board3.scale.y=boardScale*yScale;

            board4.position.x = 1.404*xSize - xAdjust;
            board4.position.y = 1.464*ySize - yAdjust;
            board4.scale.x=boardScale*xScale;
            board4.scale.y=boardScale*yScale;


            source.position.x = 850*xScale-xAdjust;
            source.position.y = 650*yScale-yAdjust;
            source.scale.x=1*xScale;
            source.scale.y=1*yScale;

            storytext.position.x=1060*xScale-xAdjust;
            storytext.position.y=610*yScale-yAdjust;

            G.text.resize(storyeditor, 50*xScale, 50*yScale, 1850*xScale, 520*yScale);

            holders.position.x = 960*xScale-xAdjust;
            holders.position.y = 680*yScale-yAdjust;
            holders.scale.x=1.30*xScale;
            holders.scale.y=1.30*yScale;

            for(var i=0;i<10;i++)
            {
                resultList[i].position.x = 172*xScale + 105*xScale*i + 633*xScale*Math.floor(i/5)-xAdjust;
                resultList[i].position.y = 680*yScale-yAdjust;
                resultList[i].scale.x=1.3*xScale;
                resultList[i].scale.y=1.3*yScale;
                G.text.resize(resultList[i].custom.myTextId, (127*xScale + 105*xScale*i + 633*xScale*Math.floor(i/5))-xAdjust, 590*yScale-yAdjust, 90*xScale, 60*yScale);
                resultList[i].custom.myBox.clear();
                resultList[i].custom.myBox.lineStyle(4, 0xFF00FF, 1);
                resultList[i].custom.myBox.beginFill(0xFF0000, 0.5);
                resultList[i].custom.myBox.drawRect((127*xScale + 105*xScale*i + 633*xScale*Math.floor(i/5))-xAdjust, 590*yScale-yAdjust, 90*xScale, 60*yScale);
            }


            if(mode===2 || mode==3)
            {
                for(var i=0;i<wireList.length;i++)
                {
                    wireList[i].position.x=wireList[i].custom.trueX*xScale-xAdjust;//)*xScale;
                    wireList[i].position.y=wireList[i].custom.trueY*yScale-yAdjust;//)*yScale;
                }

                rewire();
            }


            for(var i=0;i<wheelList.length;i++)
            {
                //wheelList[i].position.x=(382 + ((i/2)-(i%2)*0.5)*578 + Math.floor(i/6)*400 - Math.floor(i/12)*4268)*xScale - xAdjust;
                wheelList[i].position.x=(382 + ((i/2)-(i%2)*0.5)*578 + Math.floor(i/6)*0 - Math.floor(i/12)*3468)*xScale - xAdjust;
                wheelList[i].position.y=(299 + (i%2)*695 + Math.floor(i/12)*1250)*yScale - yAdjust;

                wheelList[i].custom.myPointer.scale.x=0.1*xScale;
                wheelList[i].custom.myPointer.scale.y=0.1*yScale;
                wheelList[i].custom.myPointer.position.x=wheelList[i].position.x;
                wheelList[i].custom.myPointer.position.y=wheelList[i].position.y-260*yScale;

                for(var j=0;j<16;j++)
                {
                    wheelList[i].custom.nodes[j][0].scale.x=0.1*xScale;
                    wheelList[i].custom.nodes[j][0].scale.y=0.1*yScale;
                    wheelList[i].custom.nodes[j][0].position.x=wheelList[i].position.x + (95*Math.sin(Math.PI/8*j))*xScale;
                    wheelList[i].custom.nodes[j][0].position.y=wheelList[i].position.y + (95*Math.cos(Math.PI/8*j))*yScale;
                    wheelList[i].custom.nodes[j][1].scale.x=0.1*xScale;
                    wheelList[i].custom.nodes[j][1].scale.y=0.1*yScale;
                    wheelList[i].custom.nodes[j][1].position.x=wheelList[i].position.x + (136*Math.sin(Math.PI/8*j))*xScale;
                    wheelList[i].custom.nodes[j][1].position.y=wheelList[i].position.y + (136*Math.cos(Math.PI/8*j))*yScale;
                    wheelList[i].custom.nodes[j][2].scale.x=0.1*xScale;
                    wheelList[i].custom.nodes[j][2].scale.y=0.1*yScale;
                    wheelList[i].custom.nodes[j][2].position.x=wheelList[i].position.x + (176*Math.sin(Math.PI/8*j))*xScale;
                    wheelList[i].custom.nodes[j][2].position.y=wheelList[i].position.y + (176*Math.cos(Math.PI/8*j))*yScale;
                    wheelList[i].custom.nodes[j][3].scale.x=0.1*xScale;
                    wheelList[i].custom.nodes[j][3].scale.y=0.1*yScale;
                    wheelList[i].custom.nodes[j][3].position.x=wheelList[i].position.x + (218*Math.sin(Math.PI/8*j))*xScale;
                    wheelList[i].custom.nodes[j][3].position.y=wheelList[i].position.y + (218*Math.cos(Math.PI/8*j))*yScale;

                    wheelList[i].custom.slices[j].clear();
                    wheelList[i].custom.slices[j].beginFill(wheelList[i].custom.slices[j].custom.fillColor);
                    wheelList[i].custom.slices[j].moveTo(wheelList[i].position.x, wheelList[i].position.y);
                    wheelList[i].custom.slices[j].lineTo(wheelList[i].position.x + (240*Math.sin(Math.PI/8*(j+0.48)))*xScale, wheelList[i].position.y + (240*Math.cos(Math.PI/8*(j+0.48)))*yScale);
                    wheelList[i].custom.slices[j].lineTo(wheelList[i].position.x + (240*Math.sin(Math.PI/8*(j-0.48)))*xScale, wheelList[i].position.y + (240*Math.cos(Math.PI/8*(j-0.48)))*yScale);
                    wheelList[i].custom.slices[j].endFill();

                    if(mode==2 || mode==3)
                    {
                        stage.addChild(wheelList[i].custom.slices[j]);
                    }

                    wheelList[i].custom.letters[j].x = wheelList[i].position.x + (190*Math.sin(Math.PI/8*j) - 10)*xScale;
                    wheelList[i].custom.letters[j].y = wheelList[i].position.y + (185*Math.cos(Math.PI/8*j) - 20)*yScale;

                    if(mode===2 || (mode==3 && wheelList[i].custom.letters[j].text!="-"))
                    {
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }

                    G.text.resize(wheelList[i].custom.myTextId, wheelList[i].position.x-113*xScale, wheelList[i].position.y-113*yScale, 226*xScale, 226*yScale);

                    wheelList[i].custom.myCenter.clear();
                    wheelList[i].custom.myCenter.lineStyle(4, 0xFFFFFF, 1);
                    wheelList[i].custom.myCenter.beginFill(0xFF0000, 0.5);
                    wheelList[i].custom.myCenter.drawRect(wheelList[i].position.x-113*xScale, wheelList[i].position.y-113*yScale, 226*xScale, 226*yScale);
                    //wheelList[i].custom.myCenter.drawCircle( wheelList[i].position.x,  wheelList[i].position.y, 120*xScale);

                    if(mode==2 || mode==3)
                    {
                        stage.addChild(wheelList[i].custom.myCenter);
                        //G.text.show(wheelList[i].custom.myTextId);
                    }


                    wheelList[i].custom.myRealDial.scale.x=0.24*xScale;
                    wheelList[i].custom.myRealDial.scale.y=0.24*yScale;
                    wheelList[i].custom.myRealDial.position.x=wheelList[i].position.x;
                    wheelList[i].custom.myRealDial.position.y=wheelList[i].position.y;

                    if(mode==3 && realism)
                    {
                        stage.addChild(wheelList[i].custom.myRealDial);
                    }

                }
            }

            if(mode===1)
            {
                for(var i=0;i<wireList.length;i++)
                {
                    wireList[i].position.x=wireList[i].custom.trueX*xScale-xAdjust;//)*xScale;
                    wireList[i].position.y=wireList[i].custom.trueY*yScale-yAdjust;//)*yScale;
                }

                rewire();

                if(action===1)
                {
                    current.rotation=Math.sin(count*0.07);
                    current.scale.x += 0.1*xScale;
                    current.scale.y += 0.1*yScale;
                    for(var i=0;i<wireList.length;i++)
                    {
                        if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                        {
                            wireList[i].scale.x=(0.05+0.02*Math.sin(count*0.07))*xScale;
                            wireList[i].scale.y=(0.05+0.02*Math.sin(count*0.07))*yScale;
                        }
                    }
                }
            }


            storybox.clear();
            storybox.lineStyle(4, 0xFF00FF, 1);
            storybox.beginFill(0xFF0000, 0.5);
            storybox.drawRect(1020*xScale-xAdjust, 570*yScale-yAdjust, 200*xScale, 155*yScale);

            tutorialNext.clear();
            tutorialNext.lineStyle(4, 0x00FF00, 1);
            tutorialNext.beginFill(0x00FF00, 0.5);
            tutorialNext.drawRect(1600*xScale, 500*yScale, 200*xScale, 100*yScale);

            tutorialBack.clear();
            tutorialBack.lineStyle(4, 0xFF0000, 1);
            tutorialBack.beginFill(0xFF0000, 0.5);
            tutorialBack.drawRect(1300*xScale, 500*yScale, 200*xScale, 100*yScale);

            if(mode===4)
            {
                tutorialRefresh();
            }
            else
            {
                G.text.hide(tutorialText);
            }

        },

        mode : function (selection)
        {
            G.pixi.stopEditing();

            var iMax=6;
            if(fourBoards)
            {
                iMax=24;
            }

            if(action===1)
            {
                action=0;
                current.scale.x -=0.1*xScale;
                current.scale.y -=0.1*yScale;
                current.rotation=0;
                for(var i=0;i<wireList.length;i++)
                {
                    if(wireList[i].custom.doShow && (wireList[i].custom.nodeOne===current || wireList[i].custom.nodeTwo===current))
                    {
                        wireList[i].scale.x=0.03*xScale;
                        wireList[i].scale.y=0.03*yScale;
                    }
                }
            }

            if(mode===4 && selection!=4)
            {
                mode=selection;

                G.text.hide(tutorialText);
                stage.removeChild(tutorialNext);
                stage.removeChild(tutorialBack);
                stage.removeChild(tutorialImg);



                G.pixi.loadProject(tutorialSave);

                return;
            }

            if(fourBoards)
            {
                stage.addChild(board2);
                stage.addChild(board3);
                stage.addChild(board4);
            }
            else
            {
                stage.removeChild(board2);
                stage.removeChild(board3);
                stage.removeChild(board4);
            }

            if(selection===1)////////////////////////////////////////////////
            {
                mode=1;
                lockBoard=false;

                stage.removeChild(storybox);
                stage.removeChild(storytext);
                G.text.hide(storyeditor);

                for(var i=0; i<10; i++)
                {
                    G.text.hide(resultList[i].custom.myTextId);
                    stage.removeChild(resultList[i].custom.myBox);
                }

                for(var i=0;i<24;i++)
                {
                    stage.removeChild(wheelList[i].custom.myPointer);

                    for(var j=0;j<16;j++)
                    {
                        for(var k=0;k<4;k++)
                        {
                            if(fourBoards || i<6)
                            {
                                stage.addChild(wheelList[i].custom.nodes[j][k]);
                            }
                            else
                            {
                                stage.removeChild(wheelList[i].custom.nodes[j][k]);
                            }
                        }
                        stage.removeChild(wheelList[i].custom.slices[j]);
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                    stage.removeChild(wheelList[i].custom.myCenter);
                    G.text.hide(wheelList[i].custom.myTextId);
                    stage.removeChild(wheelList[i].custom.myRealDial);
                }
                for(var i=0;i<wireList.length;i++)
                {
                    if(wireList[i].custom.doShow)
                    {
                        stage.addChild(wireList[i]);
                    }
                    stage.addChild(wireList[i].custom.myLine);
                }
            }
            else if(selection===2)////////////////////////////////////////////////
            {
                mode=2;
                lockBoard=false;

                stage.addChild(storybox);
                stage.addChild(storytext);

                for(var i=0; i<10; i++)
                {
                    G.text.show(resultList[i].custom.myTextId);
                    stage.addChild(resultList[i].custom.myBox);
                }

                for(var i=0;i<24;i++)
                {
                    for(var j=0;j<16;j++)
                    {
                        for(var k=0;k<4;k++)
                        {
                            if(fourBoards || i<6)
                            {
                                stage.addChild(wheelList[i].custom.nodes[j][k]);
                            }
                            else
                            {
                                stage.removeChild(wheelList[i].custom.nodes[j][k]);
                            }
                        }
                    }
                    stage.removeChild(wheelList[i].custom.myRealDial);
                }

                for(var i=0;i<wireList.length;i++)
                {
                    if(wireList[i].custom.doShow)
                    {
                        stage.addChild(wireList[i]);
                    }
                }
                rewire();

                for(var i=0;i<iMax;i++)
                {
                    stage.addChild(wheelList[i].custom.myPointer);

                    for(var j=0;j<16;j++)
                    {
                        stage.addChild(wheelList[i].custom.slices[j]);
                        stage.addChild(wheelList[i].custom.letters[j]);
                    }
                    stage.addChild(wheelList[i].custom.myCenter);
                    G.text.show(wheelList[i].custom.myTextId);
                }

                if(!fourBoards)
                {
                    for(var i=6;i<24;i++)
                    {
                        stage.removeChild(wheelList[i].custom.myPointer);

                        for(var j=0;j<16;j++)
                        {
                            stage.removeChild(wheelList[i].custom.slices[j]);
                            stage.removeChild(wheelList[i].custom.letters[j]);
                        }
                        stage.removeChild(wheelList[i].custom.myCenter);
                        G.text.hide(wheelList[i].custom.myTextId);
                    }
                }
            }
            else if(selection===3) /////////////////////////////////////////////////////////////
            {
                mode=3;
                lockBoard=false;

                stage.addChild(storybox);
                stage.addChild(storytext);

                for(var i=0; i<10; i++)
                {
                    if(resultList[i].custom.myDescription.substr(0,1)!="-")
                    {
                        G.text.show(resultList[i].custom.myTextId);
                        stage.addChild(resultList[i].custom.myBox);
                    }
                    else
                    {
                        G.text.hide(resultList[i].custom.myTextId);
                        stage.removeChild(resultList[i].custom.myBox);
                    }
                }

                for(var i=0;i<24;i++)
                {
                    for(var j=0;j<16;j++)
                    {
                        for(var k=0;k<4;k++)
                        {
                            if(fourBoards || i<6)
                            {
                                stage.addChild(wheelList[i].custom.nodes[j][k]);
                            }
                            else
                            {
                                stage.removeChild(wheelList[i].custom.nodes[j][k]);
                            }
                        }
                    }
                }

                for(var i=0;i<wireList.length;i++)
                {
                    stage.removeChild(wireList[i]);
                }
                rewire();

                for(var i=0;i<iMax;i++)
                {
                    stage.addChild(wheelList[i].custom.myPointer);

                    for(var j=0;j<16;j++)
                    {
                        stage.addChild(wheelList[i].custom.slices[j]);
                        if(wheelList[i].custom.letters[j].text!="-")
                        {

                            stage.addChild(wheelList[i].custom.letters[j]);
                        }
                        else
                        {
                            stage.removeChild(wheelList[i].custom.letters[j]);
                        }
                    }
                    stage.addChild(wheelList[i].custom.myCenter);
                    if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                    {
                        G.text.show(wheelList[i].custom.myTextId);
                    }
                    else
                    {
                        G.text.hide(wheelList[i].custom.myTextId);
                    }

                    if(realism)
                    {
                        stage.addChild(wheelList[i].custom.myRealDial);
                    }
                    else
                    {
                        stage.removeChild(wheelList[i].custom.myRealDial);
                    }
                }

                if(!fourBoards)
                {
                    for(var i=6;i<24;i++)
                    {
                        stage.removeChild(wheelList[i].custom.myPointer);

                        for(var j=0;j<16;j++)
                        {
                            stage.addChild(wheelList[i].custom.slices[j]);
                            stage.removeChild(wheelList[i].custom.letters[j]);
                        }
                        stage.removeChild(wheelList[i].custom.myCenter);
                        G.text.hide(wheelList[i].custom.myTextId);
                    }
                }

                stage.addChild(source);
                for(var i=0;i<10;i++)
                {
                    stage.addChild(resultList[i]);
                }
            }
            else if(selection===4)////////////////////////////////////////////////
            {
                if(mode!==4)
                {
                    G.pixi.saveProject();
                    tutorialSave=G.monitor.get();
                }

                mode=4;
                lockBoard=true;
                xAdjust=0;
                yAdjust=0;

                stage.removeChild(storybox);
                stage.removeChild(storytext);
                G.text.hide(storyeditor);

                for(var i=0; i<10; i++)
                {
                    G.text.hide(resultList[i].custom.myTextId);
                    stage.removeChild(resultList[i].custom.myBox);
                }

                for(var i=0;i<4;i++)
                {
                    stage.removeChild(wheelList[i].custom.myPointer);

                    for(var j=0;j<16;j++)
                    {
                        for(var k=0;k<4;k++)
                        {
                            stage.addChild(wheelList[i].custom.nodes[j][k]);
                        }
                        stage.removeChild(wheelList[i].custom.slices[j]);
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                    stage.removeChild(wheelList[i].custom.myCenter);
                    G.text.hide(wheelList[i].custom.myTextId);
                }

                for(var i=4;i<24;i++)
                {
                    stage.removeChild(wheelList[i].custom.myPointer);

                    for(var j=0;j<16;j++)
                    {
                        for(var k=0;k<4;k++)
                        {
                            stage.removeChild(wheelList[i].custom.nodes[j][k]);
                        }
                        stage.removeChild(wheelList[i].custom.slices[j]);
                        stage.removeChild(wheelList[i].custom.letters[j]);
                    }
                    stage.removeChild(wheelList[i].custom.myCenter);
                    G.text.hide(wheelList[i].custom.myTextId);
                    stage.removeChild(wheelList[i].custom.myRealDial);
                }

                for(var i=0;i<wireList.length;i++)
                {
                    if(wireList[i].custom.doShow)
                    {
                        stage.addChild(wireList[i]);
                    }
                    stage.addChild(wireList[i].custom.myLine);
                }

                G.text.show(tutorialText);
                stage.addChild(tutorialNext);
                stage.addChild(tutorialBack);
                stage.addChild(tutorialImg);

                tutorialRefresh();
            }
        },

        myMode : function()
        {
            return mode;
        },

        preLoadProject : function(selection)
        {
            if(selection==="MFTest")
            {
                var gaytest="";
                G.pixi.loadProject(gaytest);
            }
            else if(selection==="Jealous")
            {
                var jell="- Write a description for this creation here//*//-1**&00080,-1**&02000,-1**&04120,0008102080,0208002070,0208104080,0407004080,0200104000,0207104060,0406004050,04081-4**&,04071-3**&,04061-3**&,04051-2**&,0415004000,04001-3**&,04151-2**&,04121-2**&,0400004001,0408004081,0412004121,0200002001,0208002081,0008000081";
                G.pixi.loadProject(jell);
            }
            else if(selection==="Nim")
            {
                var nimrod="";
                G.pixi.loadProject(nimrod);
            }
            else if(selection==="TTT")
            {
                var tictak="";
                G.pixi.loadProject(tictak);
            }
            else if(selection==="Uranium")
            {
                var example="A Uranium shipment is being sent to one of Jupiter's moons, but the shipment is being hunted by space pirates. The Uranium carrier is guarded by a fighter ship  with superior firepower, but the pirates are wary of this. The shipment needs to pass around one of two asteroids, Pallas or Hermes, and the pirates can be lurking around either route. The shipment crew has the option of sending their fighter before or after the uranium carrier, and both ships can travel across either asteroid. The pirates can choose to attack the first ship they see or wait for the second, as well as which asteroid they lie in wait at.//*//-1**&00070,0007000080,0208002070,0200002150,0407004080,0404004030,0300003001,0304103040,0308003081,0312103120,0314203143,0302203023,0306303062,0310203103,0108001070,0308003070,0306203052,0304003030,0302203012,0300003150,0314203132,0312003110,0310203092,0400004150,0412004110,0008102080,0007102150,0208104080,0207104040,0200104150,0215104120,0408101070,0411101000,0100001150,0108103080,0107103062,0407103040,0404103022,0415103000,0412103142,0100103120,0115103102,03081-7**&,03071-a**&,03063-9**&,03053-7**&,03041-7**&,03031-8**&,04031-8**&,04001-8**&,03023-a**&,03013-8**&,03001-a**&,03151-8**&,03143-7**&,03133-8**&,03121-7**&,03111-a**&,03103-9**&,03093-7**&,0200002001,0208002081,0400004001,0404004041,0408004081,0412004121,0100001001,0108001081,0008000081,0099:Pirates start at Pallas or Hermes,0007:Hermes,0008:Pallas,0199:Fighters go before or after Uranium,0107:After,0108:Before,0299:Fighters start at Pallas or Hermes,0207:Hermes,0208:Pallas,0399:Pirates attack first ship or second,0307:Second,0308:First,0499:Uranium starts at Pallas or Hermes,0407:Hermes,0408:Pallas,-7**:Pirates Destroyed,-8**:No Combat,-9**:Both Destroyed,-a**:Uranium Captured";
                G.pixi.loadProject(example);
            }
            else if(selection==="ThreeFloorLight")
            {
            //    var turnOff="-1-1s00072,0007200082,0008302082,0208202072,0200202152,0007302152,0215302083,0200302073,0208304083,0207304073,0407204082,04082-2-2s,0008200083,0408204083,0200202003,0208202083";
                var turnOff="A man lives in a house with three floors, but the lights for each floor are wired together and share the same switches. Two 'on' switches on any two floors will therefor cancel eachother out, leaving  the confused man with no lights and an 'On' switch in front of him.//*//-1**&00072,0007200082,0008302082,0208202072,0200202152,0007302152,0215302083,0200302073,0208304083,0207304073,0407204082,04082-7**&,0200202003,0208202083,0008200083,0408204083,0099:First Floor,0007:off,0008:On,0299:Second Floor,0207:off,0208:On,0499:Third Floor,0407:off,0408:On,-7**:Light is on";
                G.pixi.loadProject(turnOff);
            }
            else if(selection==="Flashlight")
            {
                var basic="A man desires to make a flashlight, which will shine when he turns it on, and go dark when he turns the switch off.//*//-1**&00080,00081-6**&,0008000081,0099:State of the switch,0007:off,0008:On,-6**:Light is shining";
                G.pixi.loadProject(basic);
            }
            else if(selection==="HallLight")
            {
                var twofloor="A man desires to turn on or off the downstairs hall light either from the downstairs hall or the upstairs hall. He wants a circuit so that if either switch is turned, the light will go on if it was off, and off if it was on.//*//-1**&00080,0008102080,0007102070,0008000070,0008000081,0208002081,-6**&02071,02081-6**&,0099:Floor 1 switch,0007:off,0008:On,0299:Floor 2 switch,0207:off,0208:On,-6**:Light is on";
                G.pixi.loadProject(twofloor);
            }
            else if(selection==="Doorbell")
            {
                var ringding="A man has four doors to his house, a front door, a back door, a side door, and a door to the garden. If anyone comes to any of these doors, and rings, the doorbell should ring.//*//-1**&00080,-1**&02080,-1**&04080,-1**&01080,01081-6**&,00081-6**&,02081-6**&,04081-6**&,0008000081,0108001081,0208002081,0408004081,0099:Front door,0007:Not ringing,0008:Ringing,0199:Garden door,0107:Not ringing,0108:Ringing,0299:Back door,0207:Not ringing,0208:Ringing,0499:Side door,0407:Not ringing,0408:Ringing,-6**:Ringing";
                G.pixi.loadProject(ringding);
            }
            else if(selection==="PorchLight")
            {
                var lightyard="A man has a light on his front porch which lights up his front steps and his yard. He wants to be able to turn that light on or off from any of three places: his downstairs front hall, the upstairs landing, and the attic. Three switches are to be put in and wired so that throwing any switch one way turns the light on if it is off, and thens the light off if it is on.//*//-1**&00080,0008000070,0008102080,0208104080,04081-7**&,0007102150,0208002070,0200002150,0207104070,04071-7**&,0200104030,0404002151,04041-7**&,04031-7**&,0404004041,0408004081,0200002001,0208002081,0008000081,0099:Hall switch,0007:off,0008:On,0299:Upstairs switch,0207:off,0208:On,0499:Attic switch,0407:off,0408:On,-7**:Yard light on";
                G.pixi.loadProject(lightyard);
            }
            else if(selection==="BurglarAlarm")
            {
                var whatboutsanta="A man has two doors to his house, and two large windows on the ground floor. He believes that if a burglar should try to enter his house, the burglar would come in through one of the doors or one of the big windows. He desires an alarm system. If either door is opened or if either one of the two big windors is opened, after either one of two locking switches (one indoor for use at night, one outdoors in the garage for use when the house is left with no one in it) has been closed, then the burglar alarm is to ring.//*//-1**&00080,-1**&02080,0008102013,0208102013,0201302023,0202304080,0202305080,0202303080,0202301080,01081-6**&,03081-6**&,05081-6**&,04081-6**&,0008000081,0108001081,0208002081,0308003081,0408004081,0508005081,0099:Lock 1,0007:off,0008:On,0199:Door 2,0107:Shut,0108:Open,0299:Lock 2,0207:off,0208:On,0399:Window 1,0307:Shut,0308:Open,0499:Door 1,0407:Shut,0408:Open,0599:Window 2,0507:Shut,0508:Open,-6**:Alarm ringing";
                G.pixi.loadProject(whatboutsanta);
            }
            else if(selection==="Furnace")
            {
                var autofurnace="A man has an automatic oil furnace which burns oil and makes water into steam to heat the radiators in the house. The flame starts when the thermostat in his living room calls for heat, and stops when the thermostat stops calling for heat. But if any one of the following conditions exist, the furnace is not allowed to heat: The chimney is too hot, the pressure in the boiler is over 15lbs/in^2 above atmosphere, the fuel in the tank is low, the blower that mixes air with oil and blows the mixture into the furnace is not working, or the water level in the boiler is below a cartain mark.//*//-1**&00080,0008000081,0008102070,0207104070,-7**&05071,0507003071,0307001071,0107004071,0108001081,0208002081,0308003081,0408004081,0508005081,0099:Thermostat,0007:No heat wanter,0008:Heat wanter,0199:Fuel,0107:OK,0108:Too low,0299:Chimney,0207:Not too hot,0208:Too hot,0399:Blower,0307:OK,0308:Not working,0499:Pressure,0407:OK,0408:Too high,0599:Water level,0507:OK,0508:Too low,-7**:Furnace burning";
                G.pixi.loadProject(autofurnace);
            }
            else if(selection==="Signals")
            {
                var threeSigils="Set up a machine so that each of one three boys, George, Tom, and Dick can signal any one of the other two.//*//-1**&00080,-1**&04080,-1**&02090,0209002070,0008000070,0408004090,00081-2**&,00071-3**&,02091-4**&,02071-5**&,04091-6**&,04081-7**&,0208002081,0008000081,0408004081,0099:George's Signal,0007:Dick,0008:Tom,0009:Off,0299:Tom's Signal,0207:Dick,0208:Off,0209:George,0499:Dick's Signal,0407:Off,0408:Tom,0409:George,-2**:George to Tom,-3**:George to Dick,-4**:Tom to George,-5**:Tom to Dick,-6**:Dick to George,-7**:Dick to Tom";
                G.pixi.loadProject(threeSigils);
            }
            else if(selection==="Airlock")
            {
                var ss13="The airlock of a space ship has: an inner door that goes from the airlock to the inside of the spaceship; an outer door which goes from the airlock to the surface of the strange planet, which is assumed to have no atmosphere; a pump which pumps the air from the airlock into the space ship; a valve which allows air from the space ship to flow into the airlock; and a pressure gage which reports the air pressure in the airlock and which may be either high or low. There are four lights in the airlock: safe to open the inner door; safe to open the outer door; dangerous to open either door, conditions OK; dangerous to open either door, conditions bad. We want a warning circuit and automatic locks corresponding.//*//04081-2**&,04071-3**&,0408004070,-1**&00080,0207104080,0008102080,0208002070,02081-4**&,0008000070,0007102000,0200002150,02001-5**&,02151-4**&,0408004081,0200002001,0208002081,0008000081,0099:Valve,0007:Open,0008:Shut,0299:Pump,0207:off,0208:On,0499:Gage,0407:Zero pressure,0408:Full pressure,-2**:Inner is safe,-3**:Outer is safe,-4**:Neither but OK,-5**:Neither & bad";
                G.pixi.loadProject(ss13);
            }
            else if(selection==="FarmMachine")
            {
                var oldPuzzle="A farmer had a fox, a hen, some corn, and a hired man, and two barns, where one or more of them could be at any one time. He did not trust his hired man's carefulness. He wanted a warning robot to shine a danger light (1) when the fox was with the hen in either barn, the hired man being in the other barn, and (2) when the hen was with the corn in either barn, the hired man being in the other barn, and a safety light on other occasions.//*//-1**&00080,0008000070,0400004150,0408004070,0008104080,04081-2**&,0007104150,04151-2**&,0407102070,0207002080,02071-3**&,0208101080,0108001070,01081-2**&,01071-3**&,0400102000,0200002150,0215101000,0100001150,02001-3**&,01151-2**&,01001-3**&,0200002001,0208002081,0008000081,0100001001,0108001081,0400004001,0408004081,0099:Hired man's location,0007:2nd barn,0008:1st barn,0199:Corn's location,0107:2nd barn,0108:1st barn,0299:Fox's location,0207:2nd barn,0208:1st barn,0499:Hen's location,0407:2nd barn,0408:1st barn,-2**:Safety Light,-3**:Danger Light";
                G.pixi.loadProject(oldPuzzle);
            }
            else if(selection==="JellWives")
            {
                var jelly="One summer two families vacation in neighboring bungalows on the shore of a pleasant lake. The two wives are jealous, and one day agree that the husband of either one may not go canoeing alone with the other wife, unless accompanied by a chaperon. They also believe that the chaperon might be more attractive than they would wish, and consequently they agree that neither husband should go camping with the chaperon.                They arrange with an electrician to set up an apparently innocuous wiring system in the boat house, and they arrange with the boat boy to turn switches to show who is out in the canoe. In their living rooms, they arange a danger light to shine when the situation is contrary to their agreement, and a safety light to shine on all other occasions.//*//-1**&00080,0008000070,0208002070,0008102080,0200002150,0007102150,02151-3**&,02081-3**&,0108001070,0107002071,01071-3**&,0200104080,0408004070,04071-3**&,0400004150,0108104150,0400103070,0307003080,03081-3**&,03071-2**&,0415103072,0307203082,03073-3**&,03083-2**&,0408101000,0100001150,0115103150,0315003000,03151-3**&,03001-2**&,0100103152,0315203002,03153-2**&,03003-3**&,0008000081,0200002001,0208002081,0100001001,0108001081,0300003001,0300203003,0308003081,0308203083,0400004001,0408004081,0099:Husband One,0007:In canoe,0008:Not in canoe,0199:Wife Two,0107:In canoe,0108:Not in canoe,0299:Husband Two,0207:In canoe,0208:Not in canoe,0399:Chaperon,0307:In canoe,0308:Not in canoe,0499:Wife One,0407:In canoe,0408:Not in canoe,-2**:Danger,-3**:Safety";
                G.pixi.loadProject(jelly);
            }
            else if(selection==="MacWill")
            {
                var killbro="The provisions of Douglas Macdonald's will are as follows: 'If my son Angus survives me and my son Brian does not, all my estate goes to Angus. If Brian survives me and Angus does not, all my estate goes to Brian. If neither survives me, my estate is to go to the Gaelic Home for the Aged and Indigent. If both Angus and Brian survive me, and if at the time of my death neither is married nor is a graduate of Edinburgh University, then each shall have 50% of my estate. If both are married and neither is a graduate, or if both are graduates, and neither is married, or if both are married and both are graduates, then each shall have 50% of my estate. If only one of my sons is a graduate, his share shall be increased by 20% of my estate and the other's decreased accordingly. If only one of my sons is married, his share shall be increased by 10% and the other's decreased the same.'//*//-1**&00080,0008000070,0007101080,0108001070,01081-3**&,01071-4**&,0008101000,0100001150,01151-2**&,0100102080,0208002070,0208103080,0308003070,0300003150,0408004070,0414004130,0402004030,0508005070,0506005050,0503005020,0501005000,0514005130,0512005110,0207103000,0308104080,0307104130,0315104080,0300104020,0408105080,0407105060,05081-8**&,05051-8**&,-7**&05061,05071-9**&,0414105110,0413105130,05121-a**&,05111-b**&,05131-a**&,05141-9**&,0403105030,0402105010,05011-5**&,05001-6**&,05031-6**&,05021-7**&,0008000081,0100001001,0108001081,0300003001,0308003081,0501005011,0503005031,0506005061,0508005081,0512005121,0514005141,0208002081,0403004031,0408004081,0414004141,0099:Angus is alive,0007:False,0008:True,0199:Brian is living,0107:False,0108:True,0299:Angus is a graduate,0207:False,0208:True,0399:Brian is a graduate,0307:False,0308:True,0499:Angus is married,0407:False,0408:True,0599:Brian is married,0507:False,0508:True,-2**:All to Angus,-3**:All to Brian,-4**:All to Gaelic,-5**:20% to Angus,-6**:30% to Angus,-7**:40% to Angus,-8**:50% to Angus,-9**:60% to Angus,-a**:70% to Angus,-b**:80% to Angus";
                G.pixi.loadProject(killbro);
            }
            else if(selection==="ThreeSafe")
            {
                var easySafe="Set up a machine with the following properties: each one of the three switches may be set at any digit from 0 to 9; when and only when the first switch is set at 5, the second digit at 6, and the third digit at 3, a light 'Open' till glow.//*//-1**&00040,04061-2**&,0203000041,0203104060,0008000081,0208002081,0408004081,0099:First switch,0000:9,0001:8,0002:7,0003:6,0004:5,0005:4,0006:3,0007:2,0008:1,0015:0,0299:Second switch,0200:9,0201:8,0202:7,0203:6,0204:5,0205:4,0206:3,0207:2,0208:1,0215:0,0499:Thrid switch,0400:9,0401:8,0402:7,0403:6,0404:5,0405:4,0406:3,0407:2,0408:1,0415:0,-2**:Open";
                G.pixi.loadProject(easySafe);
            }
            else if(selection==="ThreeCombo")
            {
                var selfCombo="Set up a machine with the following properties: you may use any three digit combination with digits 1 to 9 on three switches; when and only when three more switches are set with the same combinations but each digit one less, a light 'Open' will glow.//*//-1**&00080,0007000080,0007000060,0006000050,0005000040,0003000040,0003000020,0002000010,0000000010,0208002070,0207002060,0206002050,0205002040,0204002030,0203002020,0202002010,0200002010,0408004070,0407004060,0406004050,0404004050,0404004030,0403004020,0402004010,0401004000,0008101080,0107000071,0006101060,0105000051,0004101040,0103000031,0002101020,0000101000,0101000011,0100101011,0101101021,0108101071,0107101061,0106101051,0105101041,0104101031,0103101021,0108102000,0308103071,0307103061,0306103051,0305103041,0304103031,0303103021,0302103011,0301103001,0308002081,0207103070,0306002061,0205103050,0304002041,0203103030,0302002021,0201103010,0300002001,0308104080,0508105071,0507105061,0506105051,0505105041,0504105031,0503105021,0502105011,0501105001,05081-2**&,0508004081,0407105070,0506004061,0405105050,0504004041,0403105030,0502004021,0401105010,0500004001,0008000081,0108001081,0208002081,0308003081,0408004081,0508005081,0099:Combination switch 1,0000:9,0001:8,0002:7,0003:6,0004:5,0005:4,0006:3,0007:2,0008:1,0199:Unlock switch 1,0100:8,0101:7,0102:6,0103:5,0104:4,0105:3,0106:2,0107:1,0108:0,0299:Combination switch 2,0200:9,0201:8,0202:7,0203:6,0204:5,0205:4,0206:3,0207:2,0208:1,0399:Unlock switch 2,0300:8,0301:7,0302:6,0303:5,0304:4,0305:3,0306:2,0307:1,0308:0,0499:Combination switch 3,0400:9,0401:8,0402:7,0403:6,0404:5,0405:4,0406:3,0407:2,0408:1,0599:Unlock switch 3,0500:8,0501:7,0502:6,0503:5,0504:4,0505:3,0506:2,0507:1,0508:0,-2**:Open";
                G.pixi.loadProject(selfCombo);
            }
            else if(selection==="MasFemtest")
            {
                var rigged="Set up a machine which will determine whether the person who answers five questions (if he or she answers them truthfully) is more masculine or more feminine:         (1) Whom do you prefer: Marilyn Monroe or Liberace?  (2) How would you put a thread into a small hole: Wet it or Tap it? (3) Which would you agree with: Women are better drivers than men because they are more careful, or Men are better drivers than women because they get more practice and are more skilled? (4) Would you rather spend a day: Shopping on Fifth Avenue, or Hunting in the woods? (5) Which makes a better toy for a child: an electric train, or a doll with a complete wardrobe?//*//-1**&00080,0008000070,0208002070,0200002150,0408004070,0402004010,0414004130,0108001070,0100001150,0308003070,03071-3**&,03081-2**&,0008102080,0208104080,04081-2**&,0007102150,0215104130,04131-3**&,0200104010,0207104010,0407101070,0402101070,0414101000,0401101000,01081-2**&,01151-3**&,0107103080,0100103080,0200002001,0208002081,0308003081,0100001001,0108001081,0008000081,0402004021,0408004081,0414004141,0099:Liberace or Marilyn Monroe,0007:Marilyn Monroe,0008:Liberace,0199:Prefer hunting or shopping,0107:Hunting,0108:Shopping,0299:Wet or Tap a thread,0207:Tap it,0208:Wet it,0399:Electric train or doll with wardrobe,0307:Electric train,0308:Doll with wardrobe,0499:Do men or women drive better,0407:Men better,0408:Women better,-2**:More feminine,-3**:More masculine";
                G.pixi.loadProject(rigged);
            }
            else if(selection==="Adder")
            {
                var whyfive="We have two switches A and B, each able to be set at any one of four positions 5, 6, 7, 8. We have seven lights labeled 10, 11, 12, 13, 14, 15, 16. We want a circuit so that the machine will show the sum of the numbers set on the A and B switches, if you had added switch A to switch B.//*//-1**&00080,0008000070,0007000060,0006000050,0008102080,0208002070,0207002060,0206002050,0204002030,0203002020,0202002010,0201002000,0215002140,0214002130,0213002120,0212002110,0210202092,0209202082,0208202072,0007102040,0006102110,0005102102,02081-2**&,-3**&02071,02061-4**&,-5**&02051,02041-3**&,-4**&02031,02021-5**&,-6**&02001,02151-4**&,-5**&02141,02131-6**&,02121-7**&,02073-8**&,-7**&02083,-6**&02093,02103-5**&,02011-6**&,0008000081,0204002041,0208002081,0210202103,0215002151,0099:Switch one,0005:8,0006:7,0007:6,0008:5,0299:Switch two,0205:8,0206:7,0207:6,0208:5,-2**:10,-3**:11,-4**:12,-5**:13,-6**:14,-7**:15,-8**:16";
                G.pixi.loadProject(whyfive);
            }
            else if(selection==="Subber")
            {
                var stillwhyfive="We have two switches A and B, each able to be set at any one of four positions 5, 6, 7, 8. We have seven lights labeled 10, 11, 12, 13, 14, 15, 16. We want a circuit so that the machine will show the sum of the numbers set on the A and B switches, if you had subtracted switch A from switch B.//*//-1**&00080,0008000070,0007000060,0006000050,0207002060,0206002050,0203002020,0202002010,0201002000,0210202092,0209202082,0208202072,0208002070,0214002130,0213002120,0212002110,0211002100,0008102080,0007102000,0210000061,0210200051,02081-5**&,02071-6**&,02061-7**&,02051-8**&,02031-4**&,02021-5**&,02011-6**&,02001-7**&,02141-3**&,02131-4**&,02103-2**&,02093-3**&,02083-4**&,02073-5**&,-5**&02121,02111-6**&,0008000081,0203002031,0208002081,0210202103,0214002141,0099:Switch one,0005:8,0006:7,0007:6,0008:5,0299:Switch two,0205:8,0206:7,0207:6,0208:5,-2**: -3,-3**: -2,-4**: -1,-5**:0,-6**:1,-7**:2,-8**:3";
                G.pixi.loadProject(stillwhyfive);
            }
            else if(selection==="Multer")
            {
                var forgotone="We have two switches A and B, each able to be set at any one of four positions 6, 7, 8, 9. We have ten lights labeled 36, 42, 48, 49, 54, 63, 64, 72, 81. We want a circuit so that the machine will show the product of the numbers set on the A and B switches, by shining the appropriate light.//*//-1**&00080,0008000070,0007000060,0006000050,0207002060,0206002050,0203002020,0202002010,0201002000,0210202092,0209202082,0208202072,0208002070,0214002130,0213002120,0212002110,0211002100,0008102080,0007102000,0210000061,0210200051,02081-2**&,-6**&02051,02071-3**&,02061-4**&,02031-3**&,02021-5**&,-8**&02001,02011-7**&,02141-4**&,02131-7**&,02121-9**&,02111-a**&,02103-6**&,-8**&02093,-a**&02083,02073-b**&,0203002031,0208002081,0210202103,0214002141,0008000081,0099:Switch one,0005:9,0006:8,0007:7,0008:6,0299:Switch two,0205:9,0206:8,0207:7,0208:6,-2**:36,-3**:42,-4**:48,-5**:49,-6**:54,-7**:56,-8**:63,-9**:64,-a**:72,-b**:81";
                G.pixi.loadProject(forgotone);
            }
            else if(selection==="Divider")
            {
                var gotitright="We have two switches, A and B, each able to be set at any one of 0, 1, 2, 3. We have ten lights labeled 0, 1/3, 1/2, 2/3, 1, 3/2, 2, 3, Infinity, ?. We want a circuit so that the machine will show the quotient of A divided by B, where A and B are numbers set on the switches.//*//-1**&00080,0008000070,0007000060,0006000050,0207002060,0206002050,0203002020,0202002010,0201002000,0210202092,0209202082,0208202072,0208002070,0214002130,0213002120,0212002110,0008102080,0007102000,0210000061,0210200051,02081-b**&,02071-2**&,02061-2**&,-2**&02051,02031-a**&,02021-6**&,02011-4**&,02001-3**&,02141-a**&,02131-8**&,02121-6**&,0210002110,02111-5**&,02103-a**&,02093-9**&,02083-7**&,02073-6**&,0008000081,0203002031,0208002081,0210202103,0214002141,0099:Switch one,0005:3,0006:2,0007:1,0008:0,0299:Switch two,0205:3,0206:2,0207:1,0208:0,-2**:0,-3**:1/3,-4**:1/2,-5**:2/3,-6**:1,-7**:3/2,-8**:2,-9**:3,-a**:Infinity,-b**:?";
                G.pixi.loadProject(gotitright);
            }
            else if(selection==="Carry")
            {
                var oldmath="We have two switches, A which may be set at any one of the numbers 3, 4, 5, 6 and B which may be set at any one of the numbers 2, 3, 4, 5, 6, 7. We have two lights Carry One, and No Carry. We want a machine so that these lights will be turned on properly.//*//-1**&00080,0008000070,0007000060,0006000050,0008102080,0208002070,0207002060,0206002050,0205002040,0204002030,02071-3**&,02061-3**&,02051-3**&,02041-3**&,0007102082,0208202072,0207202062,0206202052,0205202042,0204202032,02081-3**&,02031-2**&,02033-2**&,02043-2**&,-3**&02053,02063-3**&,02073-3**&,02083-3**&,0006102000,0200002150,0215002140,0214002130,0213002120,0212002110,02001-3**&,02151-3**&,02141-3**&,02131-2**&,02121-2**&,02111-2**&,0005102002,0200202152,0215202142,0214202132,0213202122,0212202112,02003-3**&,02153-3**&,02143-2**&,02133-2**&,02123-2**&,02113-2**&,0200002001,0200202003,0208002081,0208202083,0008000081,0099:Switch A,0005:6,0006:5,0007:4,0008:3,0299:Switch B,0203:7,0204:6,0205:5,0206:4,0207:3,0208:2,-2**:Carry One,-3**:No Carry";
                G.pixi.loadProject(oldmath);
            }
            else if(selection==="Comparer")
            {
                var nothardbro="We have two switches A and B, each able to be set at any one of four numbers 6, 8, 10, 12. We have three lights labeled GREATER, EQUAL, LESS. We want a sircuit that will show whether A is greater than B, or A is equal to B, or A is less than B, where A and B are the numbers set on the switches.//*//-1**&00080,0008000070,0007000060,0006000050,0008102080,0208002070,0207002060,0206002050,0007102082,0208202072,0207202062,0206202052,0006102000,0200002150,0215002140,0214002130,0005102002,0200202152,0215202142,0214202132,02133-3**&,02141-3**&,02073-3**&,02081-3**&,02071-4**&,02061-4**&,02051-4**&,02063-4**&,02053-4**&,02131-4**&,02143-2**&,02153-2**&,02003-2**&,02151-2**&,02001-2**&,02083-2**&,0008000081,0200002001,0200202003,0208002081,0208202083,0099:Switch A,0005:12,0006:10,0007:8,0008:6,0299:Switch B,0205:12,0206:10,0207:8,0208:6,-2**:Greater,-3**:Equal,-4**:Less";
                G.pixi.loadProject(nothardbro);
            }
            else if(selection==="Signals")
            {
                var threeSigils="";
                G.pixi.loadProject(threeSigils);
            }
            else if(selection==="Signals")
            {
                var threeSigils="";
                G.pixi.loadProject(threeSigils);
            }
        },

        loadProject : function (saveStr)
        {
            G.pixi.clearAll();

            if(mode===4)
            {
                G.pixi.mode(1);
            }

            var storyAndPlot=saveStr.split("//*//");

            G.text.set(storyeditor, storyAndPlot[0]);

            var saveArray= storyAndPlot[1].split(',');

            for(var i=0;i<saveArray.length;i++)
            {
                if(saveArray[i].substr(4,1)!=":")
                {
                    var wheelOne=saveArray[i].substr(0,2);
                    var lineOne=saveArray[i].substr(2,2);
                    var rankOne=saveArray[i].substr(4,1);
                    var nodeUno=null;

                    if(wheelOne.charAt(0)=="-")
                    {
                        if(wheelOne.charAt(1)=="1")
                        {
                            nodeUno=source;
                        }
                        else if(wheelOne.charAt(1)=="2")
                        {
                            nodeUno=resultList[0];
                        }
                        else if(wheelOne.charAt(1)=="3")
                        {
                            nodeUno=resultList[1];
                        }
                        else if(wheelOne.charAt(1)=="4")
                        {
                            nodeUno=resultList[2];
                        }
                        else if(wheelOne.charAt(1)=="5")
                        {
                            nodeUno=resultList[3];
                        }
                        else if(wheelOne.charAt(1)=="6")
                        {
                            nodeUno=resultList[4];
                        }
                        else if(wheelOne.charAt(1)=="7")
                        {
                            nodeUno=resultList[5];
                        }
                        else if(wheelOne.charAt(1)=="8")
                        {
                            nodeUno=resultList[6];
                        }
                        else if(wheelOne.charAt(1)=="9")
                        {
                            nodeUno=resultList[7];
                        }
                        else if(wheelOne.charAt(1)=="a")
                        {
                            nodeUno=resultList[8];
                        }
                        else if(wheelOne.charAt(1)=="b")
                        {
                            nodeUno=resultList[9];
                        }
                        else
                        {
                            //TODO: error here?
                            nodeUno=source;
                        }
                    }
                    else
                    {
                        nodeUno=wheelList[parseInt(wheelOne)].custom.nodes[parseInt(lineOne)][parseInt(rankOne)];
                    }

                    var wheelTwo=saveArray[i].substr(5,2);
                    var lineTwo=saveArray[i].substr(7,2);
                    var rankTwo=saveArray[i].substr(9,1);
                    var nodeDos=null;

                    if(wheelTwo.charAt(0)=="-")
                    {
                        if(wheelTwo.charAt(1)=="1")
                        {
                            nodeDos=source;
                        }
                        else if(wheelTwo.charAt(1)=="2")
                        {
                            nodeDos=resultList[0];
                        }
                        else if(wheelTwo.charAt(1)=="3")
                        {
                            nodeDos=resultList[1];
                        }
                        else if(wheelTwo.charAt(1)=="4")
                        {
                            nodeDos=resultList[2];
                        }
                        else if(wheelTwo.charAt(1)=="5")
                        {
                            nodeDos=resultList[3];
                        }
                        else if(wheelTwo.charAt(1)=="6")
                        {
                            nodeDos=resultList[4];
                        }
                        else if(wheelTwo.charAt(1)=="7")
                        {
                            nodeDos=resultList[5];
                        }
                        else if(wheelTwo.charAt(1)=="8")
                        {
                            nodeDos=resultList[6];
                        }
                        else if(wheelTwo.charAt(1)=="9")
                        {
                            nodeDos=resultList[7];
                        }
                        else if(wheelTwo.charAt(1)=="a")
                        {
                            nodeDos=resultList[8];
                        }
                        else if(wheelTwo.charAt(1)=="b")
                        {
                            nodeDos=resultList[9];
                        }
                        else
                        {
                            //todo: error here?
                            nodeDos=source;
                        }
                    }
                    else
                    {
                        nodeDos=wheelList[parseInt(wheelTwo)].custom.nodes[parseInt(lineTwo)][parseInt(rankTwo)];
                    }

                    connectNodes(nodeUno, nodeDos);
                }
                else
                {
                    var wheelNo=saveArray[i].substr(0,2);
                    var lineNo=saveArray[i].substr(2,2);
                    var newText=saveArray[i].substr(5,9999);

                    if(wheelNo.charAt(0)=="-")
                    {
                        if(wheelNo.charAt(1)=="1")
                        {
                            ; // Error here
                        }
                        else if(wheelNo.charAt(1)=="2")
                        {
                            resultList[0].custom.myDescription=newText;
                            G.text.set(resultList[0].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="3")
                        {
                            resultList[1].custom.myDescription=newText;
                            G.text.set(resultList[1].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="4")
                        {
                            resultList[2].custom.myDescription=newText;
                            G.text.set(resultList[2].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="5")
                        {
                            resultList[3].custom.myDescription=newText;
                            G.text.set(resultList[3].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="6")
                        {
                            resultList[4].custom.myDescription=newText;
                            G.text.set(resultList[4].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="7")
                        {
                            resultList[5].custom.myDescription=newText;
                            G.text.set(resultList[5].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="8")
                        {
                            resultList[6].custom.myDescription=newText;
                            G.text.set(resultList[6].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="9")
                        {
                            resultList[7].custom.myDescription=newText;
                            G.text.set(resultList[7].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="a")
                        {
                            resultList[8].custom.myDescription=newText;
                            G.text.set(resultList[8].custom.myTextId, newText);
                        }
                        else if(wheelNo.charAt(1)=="b")
                        {
                            resultList[9].custom.myDescription=newText;
                            G.text.set(resultList[9].custom.myTextId, newText);
                        }
                        else
                        {
                            ; // Error here
                        }
                    }
                    else if(lineNo=="99")
                    {
                        wheelList[parseInt(wheelNo)].custom.myDescription=newText;
                        G.text.set(wheelList[parseInt(wheelNo)].custom.myTextId, wheelList[parseInt(wheelNo)].custom.myDescription);
                    }
                    else
                    {
                        wheelList[parseInt(wheelNo)].custom.slices[parseInt(lineNo)].custom.myDescription=newText;
                        wheelList[parseInt(wheelNo)].custom.letters[parseInt(lineNo)].text=newText.charAt(0);
                    }

                }
            }


            G.pixi.mode(mode);

        },

        saveProject : function()
        {
            G.monitor.clear();

            for(var i=0;i<wheelList.length;i++)
            {
                while(wheelList[i].custom.myPointer.custom.currentPos!==8)
                {
                    incrementDial(i);
                }
            }

            var saveStr="";

            saveStr+= G.text.get(storyeditor) + "//*//";

            for(var i=0;i<wireList.length;i++)
            {

                if(wireList[i].custom.nodeOne.custom.myWheel==-10)
                {
                    saveStr=saveStr+"-a";
                }
                else if(wireList[i].custom.nodeOne.custom.myWheel==-11)
                {
                    saveStr=saveStr+"-b";
                }
                else if(wireList[i].custom.nodeOne.custom.myWheel<10 && wireList[i].custom.nodeOne.custom.myWheel>=0)
                {
                    saveStr=saveStr+"0"+wireList[i].custom.nodeOne.custom.myWheel.toString();
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeOne.custom.myWheel.toString();
                }


                if(wireList[i].custom.nodeOne.custom.myLine<10 && wireList[i].custom.nodeOne.custom.myLine>=0)
                {
                    saveStr=saveStr+"0";
                }
                if(wireList[i].custom.nodeOne.custom.myLine<0)
                {
                    saveStr=saveStr+"**";
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeOne.custom.myLine.toString();
                }

                if(wireList[i].custom.nodeOne.custom.myWheel<0)
                {
                    saveStr=saveStr+"&";
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeOne.custom.myRank.toString();
                }





                if(wireList[i].custom.nodeTwo.custom.myWheel==-10)
                {
                    saveStr=saveStr+"-a";
                }
                else if(wireList[i].custom.nodeTwo.custom.myWheel==-11)
                {
                    saveStr=saveStr+"-b";
                }
                else if(wireList[i].custom.nodeTwo.custom.myWheel<10 && wireList[i].custom.nodeTwo.custom.myWheel>=0)
                {
                    saveStr=saveStr+"0"+wireList[i].custom.nodeTwo.custom.myWheel.toString();
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeTwo.custom.myWheel.toString();
                }

                if(wireList[i].custom.nodeTwo.custom.myLine<10 && wireList[i].custom.nodeTwo.custom.myLine>=0)
                {
                    saveStr=saveStr+"0";
                }
                if(wireList[i].custom.nodeTwo.custom.myLine<0)
                {
                    saveStr=saveStr+"**";
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeTwo.custom.myLine.toString();
                }

                if(wireList[i].custom.nodeTwo.custom.myWheel<0)
                {
                    saveStr=saveStr+"&";
                }
                else
                {
                    saveStr=saveStr+wireList[i].custom.nodeTwo.custom.myRank.toString();
                }


                if(i!==wireList.length-1)
                {
                    saveStr=saveStr+",";
                }
            }

            for(var i=0;i<wheelList.length;i++)
            {
                if(wheelList[i].custom.myDescription.substr(0,1)!="-")
                {
                    saveStr=saveStr+",";
                    if(i<10)
                    {
                        saveStr=saveStr+"0"
                    }
                    saveStr=saveStr+i+"99:"+wheelList[i].custom.myDescription;
                }

                for(var j=0;j<16;j++)
                {
                    if(wheelList[i].custom.letters[j].text!="-")
                    {
                        saveStr=saveStr+",";
                        if(i<10)
                        {
                            saveStr=saveStr+"0"
                        }
                        saveStr=saveStr+i;
                        if(j<10)
                        {
                            saveStr=saveStr+"0"
                        }
                        saveStr=saveStr+j+":"+wheelList[i].custom.slices[j].custom.myDescription;
                    }
                }
            }

            for(var i=0; i<8; i++)
            {
                if(resultList[i].custom.myDescription.substr(0,1)!="-")
                {
                    saveStr=saveStr+"," + resultList[i].custom.myWheel +"**:"+resultList[i].custom.myDescription;
                }
            }
            if(resultList[8].custom.myDescription.substr(0,1)!="-")
            {
                saveStr=saveStr+",-a**:"+resultList[8].custom.myDescription;
            }
            if(resultList[9].custom.myDescription.substr(0,1)!="-")
            {
                saveStr=saveStr+",-b**:"+resultList[9].custom.myDescription;
            }

            G.monitor.say(saveStr);
        },

        clearAll : function()
        {
            G.pixi.stopEditing();
            for(var i=0;i<24;i++)
            {
                for(var j=0;j<16;j++)
                {
                    for(var k=0;k<4;k++)
                    {
                        var nodeA=wheelList[i].custom.nodes[j][k];

                        while(nodeA.custom.friends.length!==0)
                        {
                            var nodeB=nodeA.custom.friends[0];

                            severNodes(nodeA, nodeB);
                        }
                    }

                    wheelList[i].custom.letters[j].text="-";
                    stage.removeChild(wheelList[i].custom.letters[j]);

                    wheelList[i].custom.slices[j].custom.myDescription="- this is wheel #" + i + ", line #" + j;
                }
                wheelList[i].custom.myDescription="- this is wheel #" + i + ", the center";
                G.text.set(wheelList[i].custom.myTextId, wheelList[i].custom.myDescription);
                if(mode!=2)
                {
                    G.text.hide(wheelList[i].custom.myTextId);
                }
                while(wheelList[i].custom.myPointer.custom.currentPos!==8)
                {
                    incrementDial(i);
                }
            }

            while(wireList.length!==0)
            {
                wireList[0].custom.myLine.clear();
                stage.removeChild(wireList[0].custom.myLine);

                stage.removeChild(wireList[0]);

                wireList.shift();
            }

            G.text.set(storyeditor, "- Write a description for this project here");

            for(var i=0;i<10;i++)
            {
                resultList[i].custom.myDescription="- #" + (i+2) + " bulb";
                G.text.set(resultList[i].custom.myTextId, resultList[i].custom.myDescription);
            }

            if(mode!=2)
            {
                for(var i=0;i<10;i++)
                {
                    G.text.hide(resultList[i].custom.myTextId);
                    stage.removeChild(resultList[i].custom.myBox);
                }
            }
        },

        toggleRemoving : function()
        {
            if(action===0)
            {
                action=2;
            }
            else if(action===1)
            {
                current.scale.x -=0.1*xScale;
                current.scale.y -=0.1*yScale;
                current.rotation=0;
                for(var i=0;i<wireList.length;i++)
                {
                    if (wireList[i].custom.doShow && (wireList[i].custom.nodeOne === current || wireList[i].custom.nodeTwo === current)) {
                        wireList[i].scale.x = 0.03 * xScale;
                        wireList[i].scale.y = 0.03 * yScale;
                    }
                }
                action=2;
            }
            else if(action===2)
            {
                action=0;
            }
            return ( action === 2 );
        },

        toggleFourBoards : function()
        {
            if(fourBoards)
            {
                fourBoards=false;
                xAdjust=0;
                yAdjust=0;
            }
            else
            {
                fourBoards=true;
            }
            G.pixi.mode(mode);
            return fourBoards;
        },

        toggleRealism : function()
        {
            if(realism)
            {
                realism=false;
                texture = PIXI.Texture.fromImage('img/board.svg');
                board1.texture=texture;
                board2.texture=texture;
                board3.texture=texture;
                board4.texture=texture;
            }
            else
            {
                realism=true;
                texture = PIXI.Texture.fromImage('img/BoardPhoto.png');
                board1.texture=texture;
                board2.texture=texture;
                board3.texture=texture;
                board4.texture=texture;
                for(var i=0;i<24;i++)
                {
                    stage.removeChild(wheelList[i].custom.myRealDial);
                }
            }

            G.pixi.mode(mode);
            G.pixi.resize(xSize, ySize);
            return realism;
        },

        startEditing : function()
        {
            if(editing)
            {
                G.pixi.stopEditing();

                if(editW===enteredW && editL===enteredL)
                {
                    return;
                }
            }

            editing=true;
            editW=enteredW;
            editL=enteredL;
        },

        stopEditing : function()
        {
            if(editing)
            {
                editing=false;

                if(editW===-15)
                {
                    G.text.edit(storyeditor, false);

                    G.text.hide(storyeditor);
                    for(var i=0;i<24;i+=2)
                    {
                        G.text.show(wheelList[i].custom.myTextId);
                    }
                }
                else if(editW<0)
                {
                    G.text.edit(resultList[-(editW+2)].custom.myTextId, false);
                    resultList[-(editW+2)].custom.myDescription=G.text.get(resultList[-(editW+2)].custom.myTextId);
                }
                else
                {
                    G.text.edit(wheelList[editW].custom.myTextId, false);

                    if(editL===-1)
                    {
                        wheelList[editW].custom.myDescription=G.text.get(wheelList[editW].custom.myTextId);
                    }
                    else
                    {
                        wheelList[editW].custom.slices[editL].custom.myDescription=G.text.get(wheelList[editW].custom.myTextId);
                        wheelList[editW].custom.letters[editL].text=wheelList[editW].custom.slices[editL].custom.myDescription.charAt(0);
                    }
                }

                if(enteredW!=editW && editW>=0)
                {
                    G.text.set(wheelList[editW].custom.myTextId, wheelList[editW].custom.myDescription);
                }

                if(enteredW===-15)
                {
                    G.text.show(storyeditor);
                    for(var i=0;i<24;i+=2)
                    {
                        G.text.hide(wheelList[i].custom.myTextId);
                    }
                }
                else if(enteredW>=0)
                {
                    if(enteredL===-1)
                    {
                        G.text.set(wheelList[enteredW].custom.myTextId, wheelList[enteredW].custom.myDescription);
                    }
                    else
                    {
                        G.text.set(wheelList[enteredW].custom.myTextId, wheelList[enteredW].custom.slices[enteredL].custom.myDescription);
                    }
                }
            }
        },

        init : function ()
        {
			var canvas, seed;

            action=0;
            // 0 = nothing
            // 1 = selected a node
            // 2 = clicked the remove button

            editing=false;
            enteredW=-666;
            enteredL=-666;
            count=0;
            amDragging=false;
            seed =  Math.random() * 1000;
            G.rand.seed( seed );
            wheelList=[];
            nodeList=[];
            wireList=[];
            resultList=[];
            mode=1;
            xScale=1;
            yScale=1;
            xSize=1920;
            ySize=955;
            xAdjust=0;
            yAdjust=0;
            movingBoard=false;
            fourBoards=true;
            oldPosition=0;
            tutorialCount=1;
            realism=true;
            movingDial=false;
            movingWheel=0;
            oldDialX=0;

            canvas = document.getElementById( "myCanvas" );
            renderer = PIXI.autoDetectRenderer(1920*xScale, 955*yScale, {
                //1920 955
                view : canvas,
                backgroundColor : 0xc0c0c0
            } );
//			document.body.appendChild(renderer.view);

			stage = new PIXI.Container();
           // stage.interactive = true;

            texture = PIXI.Texture.fromImage('img/BoardPhoto.png');

            board1 = new PIXI.Sprite(texture);
            board1.anchor.x = 0.5;
            board1.anchor.y = 0.5;
            board1.interactive = true;
            board1.on('mousedown', boardDragStart);
            board1.on('mouseup', boardDragEnd);
            board1.on('mouseupoutside', boardDragEnd);
            board1.on('mousemove', boardDragMove);
            stage.addChild(board1);

            board2 = new PIXI.Sprite(texture);
            board2.anchor.x = 0.5;
            board2.anchor.y = 0.5;
            board2.interactive = true;
            board2.on('mousedown', boardDragStart);
            board2.on('mouseup', boardDragEnd);
            board2.on('mouseupoutside', boardDragEnd);
            board2.on('mousemove', boardDragMove);
            stage.addChild(board2);

            board3 = new PIXI.Sprite(texture);
            board3.anchor.x = 0.5;
            board3.anchor.y = 0.5;
            board3.interactive = true;
            board3.on('mousedown', boardDragStart);
            board3.on('mouseup', boardDragEnd);
            board3.on('mouseupoutside', boardDragEnd);
            board3.on('mousemove', boardDragMove);
            stage.addChild(board3);

            board4 = new PIXI.Sprite(texture);
            board4.anchor.x = 0.5;
            board4.anchor.y = 0.5;
            board4.interactive = true;
            board4.on('mousedown', boardDragStart);
            board4.on('mouseup', boardDragEnd);
            board4.on('mouseupoutside', boardDragEnd);
            board4.on('mousemove', boardDragMove);
            stage.addChild(board4);



            texture = PIXI.Texture.fromImage('img/Battery.svg');

            source=new PIXI.Sprite(texture);
            source.anchor.x = 0.5;
            source.anchor.y = 0.5;
            source.interactive = true;
            source.on('mousedown', clickNode);
            stage.addChild(source);

            source.custom = {
                myWheel : -1,
                myLine : -1,
                friends : [],
                isSource : true,
                powered : true
            };
            nodeList.push(source);



            storybox=new PIXI.Graphics();
            storybox.interactive=true;
            storybox.on('mouseover', enterStoryBox);
            storybox.on('mousedown', clickStoryBox);
            storybox.on('mouseout', exitStoryBox);
            stage.addChild(storybox);

            storytext=new PIXI.Text("Story");
            stage.addChild(storytext);


            texture = PIXI.Texture.fromImage('img/Bulb Holders.svg');
            holders= new PIXI.Sprite(texture);
            holders.anchor.x = 0.5;
            holders.anchor.y = 0.5;
            stage.addChild(holders);


            texture = PIXI.Texture.fromImage('img/Bulb Off.svg');

            for(var i=0;i<10;i++)
            {
                var newResult= new PIXI.Sprite(texture);
                newResult.anchor.x = 0.5;
                newResult.anchor.y = 0.5;
                newResult.interactive = true;
                newResult.on('mousedown', clickNode);
                stage.addChild(newResult);

                newResult.custom = {
                    myWheel : -i-2,
                    myLine : -i-2,
                    friends : [],
                    isSource : false,
                    powered : false,
                    myDescription : "- #" + (i+2) + " bulb",
                    myBox : new PIXI.Graphics()
                };

                if(i>=8)
                {
                    newResult.custom.myDescription="-#" + (i+2) + " bulb";
                }

                newResult.custom.myBox.interactive=true;
                newResult.custom.myBox.on('mouseover', enterNodeBox);
                newResult.custom.myBox.on('mouseout', exitNodeBox);
                newResult.custom.myBox.custom=new Object();
                newResult.custom.myBox.custom.myWheel=-i-2;
                stage.addChild(newResult.custom.myBox);
                nodeList.push(newResult);

                resultList.push(newResult);
            }




            //tutorialBox=new PIXI.Graphics();

            tutorialNext=new PIXI.Graphics();
            tutorialNext.interactive=true;
            tutorialNext.on('mousedown', clickTutBox);
            tutorialNext.custom=new Object();
            tutorialNext.custom.upOrDown=1;

            tutorialBack=new PIXI.Graphics();
            tutorialBack.interactive=true;
            tutorialBack.on('mousedown', clickTutBox);
            tutorialBack.custom=new Object();
            tutorialBack.custom.upOrDown=-1;

            texture = PIXI.Texture.fromImage('img/Battery.svg');
            tutorialImg= new PIXI.Sprite(texture);
            tutorialImg.anchor.x = 0.5;
            tutorialImg.anchor.y = 0.5;


            return renderer;
		},

		start : function ()
        {
            storyeditor=G.text.create( 10, function () {G.text.edit( storyeditor, true );} );
            G.text.set( storyeditor, "- Write a description for this creation here" );
            G.text.resize(storyeditor, 50*xScale, 50*yScale, 1850*xScale, 520*yScale);
            G.text.show(storyeditor);


            resultList[0].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[0].custom.myTextId, true );} );
            resultList[1].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[1].custom.myTextId, true );} );
            resultList[2].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[2].custom.myTextId, true );} );
            resultList[3].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[3].custom.myTextId, true );} );
            resultList[4].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[4].custom.myTextId, true );} );
            resultList[5].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[5].custom.myTextId, true );} );
            resultList[6].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[6].custom.myTextId, true );} );
            resultList[7].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[7].custom.myTextId, true );} );
            resultList[8].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[8].custom.myTextId, true );} );
            resultList[9].custom.myTextId=G.text.create( 2, function () {G.text.edit( resultList[9].custom.myTextId, true );} );
            for(var i=0; i<10;i++)
            {
                G.text.set( resultList[i].custom.myTextId, resultList[i].custom.myDescription );
                G.text.resize(resultList[i].custom.myTextId, (210*xScale + 80*xScale*i + 700*xScale*((i/6)%1)), 590*yScale, 60*xScale, 60*yScale);
                G.text.show(resultList[i].custom.myTextId);
            }

            tutorialText=G.text.create(10);
            G.text.set( tutorialText, "Welcome to the tutorial! Click the green next button to continue" );
            G.text.resize(tutorialText, 1300*xScale, 50*yScale, 500*xScale, 400*yScale);
            G.text.show(tutorialText);


            //result4.custom.myTextId = G.text.create( 2, function () {G.text.edit( result4.custom.myTextId, true );} );
            //G.text.set( result4.custom.myTextId, result4.custom.myDescription );
            //G.text.resize(result4.custom.myTextId, 450*xScale, 590*yScale, 60*xScale, 60*yScale);
            //G.text.show(result4.custom.myTextId);
            //
            //result5.custom.myTextId = G.text.create( 2, function () {G.text.edit( result5.custom.myTextId, true );} );
            //G.text.set( result5.custom.myTextId, result5.custom.myDescription );
            //G.text.resize(result5.custom.myTextId, 530*xScale, 590*yScale, 60*xScale, 60*yScale);
            //G.text.show(result5.custom.myTextId);
            //
            //
            //
            //result6.custom.myTextId = G.text.create( 2, function () {G.text.edit( result6.custom.myTextId, true );} );
            //G.text.set( result6.custom.myTextId, result6.custom.myDescription );
            //G.text.resize(result6.custom.myTextId, 1310*xScale, 590*yScale, 60*xScale, 60*yScale);
            //G.text.show(result6.custom.myTextId);



           // for(i=0;i<24;i++)
            //{
                spawnWheels();
            //}

            sys.resize(xSize, ySize);

			animate();

            var test1="Why is this still called PixiTest?//*//-1**&00080,0008000081,0408004081,0008102070,0408002071,04081-7**&,0208002081,0099:Is this sentence false?,0007:No,0008:Yeah,0299:Is the last sentence true?,0207:No,0208:Yes,0499:Are you sure?,0407:Not really,0408:I guess so,-7**:You're right";

            //G.monitor.clear();
            G.monitor.say( test1 );
            G.pixi.loadProject(test1);
            G.monitor.show();
		}
	}

	return sys;
} () );
