/* random.js */

// The following comments are for JSLint
/*jslint nomen: true, white: true, vars: true */
/*global document, window, screen, console, M */

// This model creates a G.rand property with a private closure

G.rand = ( function () {
	"use strict";
	var seed = 666;

	function randomizer () {
		var val;

		val = Math.sin( seed ) * 10000;
		seed += 1;
		return ( val - Math.floor( val ) );
	}

	// Any property of <sys> becomes a public property of G.rand

	var sys = {
		// G.rand.random( val )
		// val : number = value > 1
		// Returns pseudo-random value between 1 -> val inclusive (seeded)

		random : function ( val ) {
			var x;

			x = Math.floor( val );
			if ( x < 2 ) {
				return 1;
			}

			x = randomizer() * x;
			x = Math.floor( x ) + 1;
			return x;
		},

		// G.rand.seed( val )
		// val : number = value for random seed
		// Seeds random number generator
		// Returns seed value or L.ERROR

		seed : function ( val ) {
			var x;

			x = Math.floor( val );
			if ( x < 1 ) {
				x = 1;
			}

			seed = x;
			return x;
		}
	}

	return sys;
} () );

